/****************************************
Daggorath PC-Port Version 0.2.1
Richard Hunerlach
November 13, 2002

The copyright for Dungeons of Daggorath
is held by Douglas J. Morgan.
(c) 1982, DynaMicro
*****************************************/

// Dungeons of Daggorath
// PC-Port
// Filename: creature.h
//
// This class manages the creature data and movement

#ifndef DOD_CREATURE_HEADER
#define DOD_CREATURE_HEADER

#include "dod.h"

class Creature
{
public:
	// Constructor
	Creature();

	// Public Interface
	void		NEWLVL();
	int			CREGEN();
	int			CMOVE(int task, int cidx);
	bool		CWALK(dodBYTE dir, CCB * cr);
	bool		CFIND(dodBYTE rw, dodBYTE cl);
	int			CFIND2(RowCol rc);
	void		Reset();
	void		LoadSounds();
	void		UpdateCreSpeed();
	
	// Public Data Fields
	CCB			CCBLND[32];
	dodBYTE		FRZFLG;
	int			CMXPTR;
	dodBYTE		CMXLND[60];
	dodBYTE		MOVTAB[7];
	Mix_Chunk * creSound[12];
	Mix_Chunk * clank;
	Mix_Chunk * kaboom;
	Mix_Chunk *	buzz;
	int			creChannel;
	int			creChannelv;
	int			creSpeedMul;

private:
	// Internal Implementation
	void CBIRTH(dodBYTE a);

	// Data Fields
	CDB			CDBTAB[12];
	
	// Constants
	const dodBYTE	CTYPES;
	const dodBYTE	CC_LEN;
};

#endif // DOD_CREATURE_HEADER
