/****************************************
Daggorath PC-Port Version 0.2.1
Richard Hunerlach
November 13, 2002

The copyright for Dungeons of Daggorath
is held by Douglas J. Morgan.
(c) 1982, DynaMicro
*****************************************/

// Dungeons of Daggorath
// PC-Port
// Filename: data.cpp
//
// This file is sort of artificial.  It normally would go
// into the viewer.cpp file, but I got tired of scrolling
// past it, so I broke it out.  It contains all the data
// for all the vector lists used in the game.  There are
// certainly more elegant ways of doing this type of thing,
// but this was a simple way to do it from Excel.
//
// The lists below have the form:
// [0] = number of vector lists
// [1] = number of vertices in first vector list
// [2 - n] = x,y coordinates
// [n+1] = number of vertices in second vector list
// [etc.]
//
// The lists for the letters have relative positions from the
// bottom left of the letter grid.  The original font used an
// 8x8 grid, with the letters actually occupying a 5x7 area
// within it.  As I was experimenting on getting the letters
// to look right, I expanded the grid to 32x32, but I ended up
// only using multiples of 4, so these lists need to be changed
// back to their original 8x8 numbers, so a division operation
// can be eliminated in the rendering routine.
//
// Eventually this will need changed to use a less ugly method
// of initialization.  I just haven't had time to do it yet. :)

#include "viewer.h"

extern Viewer viewer;

void Viewer::initVectorLists()
{
	A_VLA[0] = 4;
	A_VLA[1] = 4;
	A_VLA[2] = 4;
	A_VLA[3] = 8;
	A_VLA[4] = 4;
	A_VLA[5] = 8;
	A_VLA[6] = 28;
	A_VLA[7] = 4;
	A_VLA[8] = 28;
	A_VLA[9] = 20;
	A_VLA[10] = 4;
	A_VLA[11] = 24;
	A_VLA[12] = 4;
	A_VLA[13] = 24;
	A_VLA[14] = 28;
	A_VLA[15] = 20;
	A_VLA[16] = 28;
	A_VLA[17] = 8;
	A_VLA[18] = 28;
	A_VLA[19] = 20;
	A_VLA[20] = 28;
	A_VLA[21] = 20;
	A_VLA[22] = 32;
	A_VLA[23] = 8;
	A_VLA[24] = 32;
	A_VLA[25] = 8;
	A_VLA[26] = 12;
	A_VLA[27] = 20;
	A_VLA[28] = 12;
	A_VLA[29] = 20;
	A_VLA[30] = 16;
	A_VLA[31] = 8;
	A_VLA[32] = 16;

	B_VLA[0] = 6;
	B_VLA[1] = 4;
	B_VLA[2] = 4;
	B_VLA[3] = 8;
	B_VLA[4] = 4;
	B_VLA[5] = 8;
	B_VLA[6] = 32;
	B_VLA[7] = 4;
	B_VLA[8] = 32;
	B_VLA[9] = 8;
	B_VLA[10] = 4;
	B_VLA[11] = 20;
	B_VLA[12] = 4;
	B_VLA[13] = 20;
	B_VLA[14] = 8;
	B_VLA[15] = 8;
	B_VLA[16] = 8;
	B_VLA[17] = 8;
	B_VLA[18] = 16;
	B_VLA[19] = 20;
	B_VLA[20] = 16;
	B_VLA[21] = 20;
	B_VLA[22] = 20;
	B_VLA[23] = 8;
	B_VLA[24] = 20;
	B_VLA[25] = 8;
	B_VLA[26] = 28;
	B_VLA[27] = 20;
	B_VLA[28] = 28;
	B_VLA[29] = 20;
	B_VLA[30] = 32;
	B_VLA[31] = 8;
	B_VLA[32] = 32;
	B_VLA[33] = 20;
	B_VLA[34] = 8;
	B_VLA[35] = 24;
	B_VLA[36] = 8;
	B_VLA[37] = 24;
	B_VLA[38] = 16;
	B_VLA[39] = 20;
	B_VLA[40] = 16;
	B_VLA[41] = 20;
	B_VLA[42] = 20;
	B_VLA[43] = 24;
	B_VLA[44] = 20;
	B_VLA[45] = 24;
	B_VLA[46] = 28;
	B_VLA[47] = 20;
	B_VLA[48] = 28;

	C_VLA[0] = 5;
	C_VLA[1] = 4;
	C_VLA[2] = 8;
	C_VLA[3] = 8;
	C_VLA[4] = 8;
	C_VLA[5] = 8;
	C_VLA[6] = 28;
	C_VLA[7] = 4;
	C_VLA[8] = 28;
	C_VLA[9] = 8;
	C_VLA[10] = 4;
	C_VLA[11] = 20;
	C_VLA[12] = 4;
	C_VLA[13] = 20;
	C_VLA[14] = 8;
	C_VLA[15] = 8;
	C_VLA[16] = 8;
	C_VLA[17] = 8;
	C_VLA[18] = 28;
	C_VLA[19] = 20;
	C_VLA[20] = 28;
	C_VLA[21] = 20;
	C_VLA[22] = 32;
	C_VLA[23] = 8;
	C_VLA[24] = 32;
	C_VLA[25] = 20;
	C_VLA[26] = 8;
	C_VLA[27] = 24;
	C_VLA[28] = 8;
	C_VLA[29] = 24;
	C_VLA[30] = 12;
	C_VLA[31] = 20;
	C_VLA[32] = 12;
	C_VLA[33] = 20;
	C_VLA[34] = 24;
	C_VLA[35] = 24;
	C_VLA[36] = 24;
	C_VLA[37] = 24;
	C_VLA[38] = 28;
	C_VLA[39] = 20;
	C_VLA[40] = 28;

	D_VLA[0] = 4;
	D_VLA[1] = 4;
	D_VLA[2] = 4;
	D_VLA[3] = 20;
	D_VLA[4] = 4;
	D_VLA[5] = 20;
	D_VLA[6] = 8;
	D_VLA[7] = 4;
	D_VLA[8] = 8;
	D_VLA[9] = 4;
	D_VLA[10] = 28;
	D_VLA[11] = 20;
	D_VLA[12] = 28;
	D_VLA[13] = 20;
	D_VLA[14] = 32;
	D_VLA[15] = 4;
	D_VLA[16] = 32;
	D_VLA[17] = 4;
	D_VLA[18] = 8;
	D_VLA[19] = 8;
	D_VLA[20] = 8;
	D_VLA[21] = 8;
	D_VLA[22] = 28;
	D_VLA[23] = 4;
	D_VLA[24] = 28;
	D_VLA[25] = 20;
	D_VLA[26] = 8;
	D_VLA[27] = 24;
	D_VLA[28] = 8;
	D_VLA[29] = 24;
	D_VLA[30] = 28;
	D_VLA[31] = 20;
	D_VLA[32] = 28;

	E_VLA[0] = 4;
	E_VLA[1] = 4;
	E_VLA[2] = 4;
	E_VLA[3] = 8;
	E_VLA[4] = 4;
	E_VLA[5] = 8;
	E_VLA[6] = 32;
	E_VLA[7] = 4;
	E_VLA[8] = 32;
	E_VLA[9] = 8;
	E_VLA[10] = 16;
	E_VLA[11] = 20;
	E_VLA[12] = 16;
	E_VLA[13] = 20;
	E_VLA[14] = 20;
	E_VLA[15] = 8;
	E_VLA[16] = 20;
	E_VLA[17] = 8;
	E_VLA[18] = 28;
	E_VLA[19] = 24;
	E_VLA[20] = 28;
	E_VLA[21] = 24;
	E_VLA[22] = 32;
	E_VLA[23] = 8;
	E_VLA[24] = 32;
	E_VLA[25] = 8;
	E_VLA[26] = 4;
	E_VLA[27] = 24;
	E_VLA[28] = 4;
	E_VLA[29] = 24;
	E_VLA[30] = 8;
	E_VLA[31] = 8;
	E_VLA[32] = 8;

	F_VLA[0] = 3;
	F_VLA[1] = 4;
	F_VLA[2] = 4;
	F_VLA[3] = 8;
	F_VLA[4] = 4;
	F_VLA[5] = 8;
	F_VLA[6] = 32;
	F_VLA[7] = 4;
	F_VLA[8] = 32;
	F_VLA[9] = 8;
	F_VLA[10] = 16;
	F_VLA[11] = 20;
	F_VLA[12] = 16;
	F_VLA[13] = 20;
	F_VLA[14] = 20;
	F_VLA[15] = 8;
	F_VLA[16] = 20;
	F_VLA[17] = 8;
	F_VLA[18] = 28;
	F_VLA[19] = 24;
	F_VLA[20] = 28;
	F_VLA[21] = 24;
	F_VLA[22] = 32;
	F_VLA[23] = 8;
	F_VLA[24] = 32;

	G_VLA[0] = 6;
	G_VLA[1] = 4;
	G_VLA[2] = 8;
	G_VLA[3] = 8;
	G_VLA[4] = 8;
	G_VLA[5] = 8;
	G_VLA[6] = 28;
	G_VLA[7] = 4;
	G_VLA[8] = 28;
	G_VLA[9] = 8;
	G_VLA[10] = 28;
	G_VLA[11] = 24;
	G_VLA[12] = 28;
	G_VLA[13] = 24;
	G_VLA[14] = 32;
	G_VLA[15] = 8;
	G_VLA[16] = 32;
	G_VLA[17] = 20;
	G_VLA[18] = 24;
	G_VLA[19] = 24;
	G_VLA[20] = 24;
	G_VLA[21] = 24;
	G_VLA[22] = 28;
	G_VLA[23] = 20;
	G_VLA[24] = 28;
	G_VLA[25] = 8;
	G_VLA[26] = 4;
	G_VLA[27] = 24;
	G_VLA[28] = 4;
	G_VLA[29] = 24;
	G_VLA[30] = 8;
	G_VLA[31] = 8;
	G_VLA[32] = 8;
	G_VLA[33] = 20;
	G_VLA[34] = 8;
	G_VLA[35] = 24;
	G_VLA[36] = 8;
	G_VLA[37] = 24;
	G_VLA[38] = 12;
	G_VLA[39] = 20;
	G_VLA[40] = 12;
	G_VLA[41] = 16;
	G_VLA[42] = 12;
	G_VLA[43] = 24;
	G_VLA[44] = 12;
	G_VLA[45] = 24;
	G_VLA[46] = 16;
	G_VLA[47] = 16;
	G_VLA[48] = 16;

	H_VLA[0] = 3;
	H_VLA[1] = 4;
	H_VLA[2] = 4;
	H_VLA[3] = 8;
	H_VLA[4] = 4;
	H_VLA[5] = 8;
	H_VLA[6] = 32;
	H_VLA[7] = 4;
	H_VLA[8] = 32;
	H_VLA[9] = 20;
	H_VLA[10] = 4;
	H_VLA[11] = 24;
	H_VLA[12] = 4;
	H_VLA[13] = 24;
	H_VLA[14] = 32;
	H_VLA[15] = 20;
	H_VLA[16] = 32;
	H_VLA[17] = 8;
	H_VLA[18] = 16;
	H_VLA[19] = 20;
	H_VLA[20] = 16;
	H_VLA[21] = 20;
	H_VLA[22] = 20;
	H_VLA[23] = 8;
	H_VLA[24] = 20;

	I_VLA[0] = 3;
	I_VLA[1] = 8;
	I_VLA[2] = 4;
	I_VLA[3] = 20;
	I_VLA[4] = 4;
	I_VLA[5] = 20;
	I_VLA[6] = 8;
	I_VLA[7] = 8;
	I_VLA[8] = 8;
	I_VLA[9] = 8;
	I_VLA[10] = 28;
	I_VLA[11] = 20;
	I_VLA[12] = 28;
	I_VLA[13] = 20;
	I_VLA[14] = 32;
	I_VLA[15] = 8;
	I_VLA[16] = 32;
	I_VLA[17] = 12;
	I_VLA[18] = 8;
	I_VLA[19] = 16;
	I_VLA[20] = 8;
	I_VLA[21] = 16;
	I_VLA[22] = 28;
	I_VLA[23] = 12;
	I_VLA[24] = 28;

	J_VLA[0] = 3;
	J_VLA[1] = 4;
	J_VLA[2] = 8;
	J_VLA[3] = 8;
	J_VLA[4] = 8;
	J_VLA[5] = 8;
	J_VLA[6] = 12;
	J_VLA[7] = 4;
	J_VLA[8] = 12;
	J_VLA[9] = 8;
	J_VLA[10] = 4;
	J_VLA[11] = 20;
	J_VLA[12] = 4;
	J_VLA[13] = 20;
	J_VLA[14] = 8;
	J_VLA[15] = 8;
	J_VLA[16] = 8;
	J_VLA[17] = 20;
	J_VLA[18] = 8;
	J_VLA[19] = 24;
	J_VLA[20] = 8;
	J_VLA[21] = 24;
	J_VLA[22] = 32;
	J_VLA[23] = 20;
	J_VLA[24] = 32;

	K_VLA[0] = 8;
	K_VLA[1] = 4;
	K_VLA[2] = 4;
	K_VLA[3] = 8;
	K_VLA[4] = 4;
	K_VLA[5] = 8;
	K_VLA[6] = 32;
	K_VLA[7] = 4;
	K_VLA[8] = 32;
	K_VLA[9] = 8;
	K_VLA[10] = 16;
	K_VLA[11] = 12;
	K_VLA[12] = 16;
	K_VLA[13] = 12;
	K_VLA[14] = 20;
	K_VLA[15] = 8;
	K_VLA[16] = 20;
	K_VLA[17] = 12;
	K_VLA[18] = 20;
	K_VLA[19] = 16;
	K_VLA[20] = 20;
	K_VLA[21] = 16;
	K_VLA[22] = 24;
	K_VLA[23] = 12;
	K_VLA[24] = 24;
	K_VLA[25] = 16;
	K_VLA[26] = 24;
	K_VLA[27] = 20;
	K_VLA[28] = 24;
	K_VLA[29] = 20;
	K_VLA[30] = 28;
	K_VLA[31] = 16;
	K_VLA[32] = 28;
	K_VLA[33] = 20;
	K_VLA[34] = 28;
	K_VLA[35] = 24;
	K_VLA[36] = 28;
	K_VLA[37] = 24;
	K_VLA[38] = 32;
	K_VLA[39] = 20;
	K_VLA[40] = 32;
	K_VLA[41] = 20;
	K_VLA[42] = 4;
	K_VLA[43] = 24;
	K_VLA[44] = 4;
	K_VLA[45] = 24;
	K_VLA[46] = 8;
	K_VLA[47] = 20;
	K_VLA[48] = 8;
	K_VLA[49] = 16;
	K_VLA[50] = 8;
	K_VLA[51] = 20;
	K_VLA[52] = 8;
	K_VLA[53] = 20;
	K_VLA[54] = 12;
	K_VLA[55] = 16;
	K_VLA[56] = 12;
	K_VLA[57] = 12;
	K_VLA[58] = 12;
	K_VLA[59] = 16;
	K_VLA[60] = 12;
	K_VLA[61] = 16;
	K_VLA[62] = 16;
	K_VLA[63] = 12;
	K_VLA[64] = 16;

	L_VLA[0] = 2;
	L_VLA[1] = 4;
	L_VLA[2] = 4;
	L_VLA[3] = 8;
	L_VLA[4] = 4;
	L_VLA[5] = 8;
	L_VLA[6] = 32;
	L_VLA[7] = 4;
	L_VLA[8] = 32;
	L_VLA[9] = 8;
	L_VLA[10] = 4;
	L_VLA[11] = 24;
	L_VLA[12] = 4;
	L_VLA[13] = 24;
	L_VLA[14] = 8;
	L_VLA[15] = 8;
	L_VLA[16] = 8;

	M_VLA[0] = 5;
	M_VLA[1] = 4;
	M_VLA[2] = 4;
	M_VLA[3] = 8;
	M_VLA[4] = 4;
	M_VLA[5] = 8;
	M_VLA[6] = 32;
	M_VLA[7] = 4;
	M_VLA[8] = 32;
	M_VLA[9] = 20;
	M_VLA[10] = 4;
	M_VLA[11] = 24;
	M_VLA[12] = 4;
	M_VLA[13] = 24;
	M_VLA[14] = 32;
	M_VLA[15] = 20;
	M_VLA[16] = 32;
	M_VLA[17] = 8;
	M_VLA[18] = 24;
	M_VLA[19] = 12;
	M_VLA[20] = 24;
	M_VLA[21] = 12;
	M_VLA[22] = 28;
	M_VLA[23] = 8;
	M_VLA[24] = 28;
	M_VLA[25] = 16;
	M_VLA[26] = 24;
	M_VLA[27] = 20;
	M_VLA[28] = 24;
	M_VLA[29] = 20;
	M_VLA[30] = 28;
	M_VLA[31] = 16;
	M_VLA[32] = 28;
	M_VLA[33] = 12;
	M_VLA[34] = 12;
	M_VLA[35] = 16;
	M_VLA[36] = 12;
	M_VLA[37] = 16;
	M_VLA[38] = 24;
	M_VLA[39] = 12;
	M_VLA[40] = 24;

	N_VLA[0] = 5;
	N_VLA[1] = 4;
	N_VLA[2] = 4;
	N_VLA[3] = 8;
	N_VLA[4] = 4;
	N_VLA[5] = 8;
	N_VLA[6] = 32;
	N_VLA[7] = 4;
	N_VLA[8] = 32;
	N_VLA[9] = 20;
	N_VLA[10] = 4;
	N_VLA[11] = 24;
	N_VLA[12] = 4;
	N_VLA[13] = 24;
	N_VLA[14] = 32;
	N_VLA[15] = 20;
	N_VLA[16] = 32;
	N_VLA[17] = 8;
	N_VLA[18] = 20;
	N_VLA[19] = 12;
	N_VLA[20] = 20;
	N_VLA[21] = 12;
	N_VLA[22] = 24;
	N_VLA[23] = 8;
	N_VLA[24] = 24;
	N_VLA[25] = 12;
	N_VLA[26] = 16;
	N_VLA[27] = 16;
	N_VLA[28] = 16;
	N_VLA[29] = 16;
	N_VLA[30] = 20;
	N_VLA[31] = 12;
	N_VLA[32] = 20;
	N_VLA[33] = 16;
	N_VLA[34] = 12;
	N_VLA[35] = 20;
	N_VLA[36] = 12;
	N_VLA[37] = 20;
	N_VLA[38] = 16;
	N_VLA[39] = 16;
	N_VLA[40] = 16;

	O_VLA[0] = 4;
	O_VLA[1] = 4;
	O_VLA[2] = 8;
	O_VLA[3] = 8;
	O_VLA[4] = 8;
	O_VLA[5] = 8;
	O_VLA[6] = 28;
	O_VLA[7] = 4;
	O_VLA[8] = 28;
	O_VLA[9] = 20;
	O_VLA[10] = 8;
	O_VLA[11] = 24;
	O_VLA[12] = 8;
	O_VLA[13] = 24;
	O_VLA[14] = 28;
	O_VLA[15] = 20;
	O_VLA[16] = 28;
	O_VLA[17] = 8;
	O_VLA[18] = 4;
	O_VLA[19] = 20;
	O_VLA[20] = 4;
	O_VLA[21] = 20;
	O_VLA[22] = 8;
	O_VLA[23] = 8;
	O_VLA[24] = 8;
	O_VLA[25] = 8;
	O_VLA[26] = 28;
	O_VLA[27] = 20;
	O_VLA[28] = 28;
	O_VLA[29] = 20;
	O_VLA[30] = 32;
	O_VLA[31] = 8;
	O_VLA[32] = 32;

	P_VLA[0] = 4;
	P_VLA[1] = 4;
	P_VLA[2] = 4;
	P_VLA[3] = 8;
	P_VLA[4] = 4;
	P_VLA[5] = 8;
	P_VLA[6] = 32;
	P_VLA[7] = 4;
	P_VLA[8] = 32;
	P_VLA[9] = 8;
	P_VLA[10] = 16;
	P_VLA[11] = 20;
	P_VLA[12] = 16;
	P_VLA[13] = 20;
	P_VLA[14] = 20;
	P_VLA[15] = 8;
	P_VLA[16] = 20;
	P_VLA[17] = 20;
	P_VLA[18] = 20;
	P_VLA[19] = 24;
	P_VLA[20] = 20;
	P_VLA[21] = 24;
	P_VLA[22] = 28;
	P_VLA[23] = 20;
	P_VLA[24] = 28;
	P_VLA[25] = 8;
	P_VLA[26] = 28;
	P_VLA[27] = 20;
	P_VLA[28] = 28;
	P_VLA[29] = 20;
	P_VLA[30] = 32;
	P_VLA[31] = 8;
	P_VLA[32] = 32;

	Q_VLA[0] = 7;
	Q_VLA[1] = 4;
	Q_VLA[2] = 8;
	Q_VLA[3] = 8;
	Q_VLA[4] = 8;
	Q_VLA[5] = 8;
	Q_VLA[6] = 28;
	Q_VLA[7] = 4;
	Q_VLA[8] = 28;
	Q_VLA[9] = 8;
	Q_VLA[10] = 4;
	Q_VLA[11] = 16;
	Q_VLA[12] = 4;
	Q_VLA[13] = 16;
	Q_VLA[14] = 8;
	Q_VLA[15] = 8;
	Q_VLA[16] = 8;
	Q_VLA[17] = 8;
	Q_VLA[18] = 28;
	Q_VLA[19] = 20;
	Q_VLA[20] = 28;
	Q_VLA[21] = 20;
	Q_VLA[22] = 32;
	Q_VLA[23] = 8;
	Q_VLA[24] = 32;
	Q_VLA[25] = 12;
	Q_VLA[26] = 12;
	Q_VLA[27] = 16;
	Q_VLA[28] = 12;
	Q_VLA[29] = 16;
	Q_VLA[30] = 16;
	Q_VLA[31] = 12;
	Q_VLA[32] = 16;
	Q_VLA[33] = 16;
	Q_VLA[34] = 8;
	Q_VLA[35] = 20;
	Q_VLA[36] = 8;
	Q_VLA[37] = 20;
	Q_VLA[38] = 12;
	Q_VLA[39] = 16;
	Q_VLA[40] = 12;
	Q_VLA[41] = 20;
	Q_VLA[42] = 4;
	Q_VLA[43] = 24;
	Q_VLA[44] = 4;
	Q_VLA[45] = 24;
	Q_VLA[46] = 8;
	Q_VLA[47] = 20;
	Q_VLA[48] = 8;
	Q_VLA[49] = 20;
	Q_VLA[50] = 12;
	Q_VLA[51] = 24;
	Q_VLA[52] = 12;
	Q_VLA[53] = 24;
	Q_VLA[54] = 28;
	Q_VLA[55] = 20;
	Q_VLA[56] = 28;

	R_VLA[0] = 7;
	R_VLA[1] = 4;
	R_VLA[2] = 4;
	R_VLA[3] = 8;
	R_VLA[4] = 4;
	R_VLA[5] = 8;
	R_VLA[6] = 32;
	R_VLA[7] = 4;
	R_VLA[8] = 32;
	R_VLA[9] = 8;
	R_VLA[10] = 28;
	R_VLA[11] = 20;
	R_VLA[12] = 28;
	R_VLA[13] = 20;
	R_VLA[14] = 32;
	R_VLA[15] = 8;
	R_VLA[16] = 32;
	R_VLA[17] = 8;
	R_VLA[18] = 16;
	R_VLA[19] = 20;
	R_VLA[20] = 16;
	R_VLA[21] = 20;
	R_VLA[22] = 20;
	R_VLA[23] = 8;
	R_VLA[24] = 20;
	R_VLA[25] = 20;
	R_VLA[26] = 20;
	R_VLA[27] = 24;
	R_VLA[28] = 20;
	R_VLA[29] = 24;
	R_VLA[30] = 28;
	R_VLA[31] = 20;
	R_VLA[32] = 28;
	R_VLA[33] = 12;
	R_VLA[34] = 12;
	R_VLA[35] = 16;
	R_VLA[36] = 12;
	R_VLA[37] = 16;
	R_VLA[38] = 16;
	R_VLA[39] = 12;
	R_VLA[40] = 16;
	R_VLA[41] = 16;
	R_VLA[42] = 8;
	R_VLA[43] = 20;
	R_VLA[44] = 8;
	R_VLA[45] = 20;
	R_VLA[46] = 12;
	R_VLA[47] = 16;
	R_VLA[48] = 12;
	R_VLA[49] = 20;
	R_VLA[50] = 4;
	R_VLA[51] = 24;
	R_VLA[52] = 4;
	R_VLA[53] = 24;
	R_VLA[54] = 8;
	R_VLA[55] = 20;
	R_VLA[56] = 8;

	S_VLA[0] = 7;
	S_VLA[1] = 4;
	S_VLA[2] = 8;
	S_VLA[3] = 8;
	S_VLA[4] = 8;
	S_VLA[5] = 8;
	S_VLA[6] = 12;
	S_VLA[7] = 4;
	S_VLA[8] = 12;
	S_VLA[9] = 20;
	S_VLA[10] = 24;
	S_VLA[11] = 24;
	S_VLA[12] = 24;
	S_VLA[13] = 24;
	S_VLA[14] = 28;
	S_VLA[15] = 20;
	S_VLA[16] = 28;
	S_VLA[17] = 8;
	S_VLA[18] = 4;
	S_VLA[19] = 20;
	S_VLA[20] = 4;
	S_VLA[21] = 20;
	S_VLA[22] = 8;
	S_VLA[23] = 8;
	S_VLA[24] = 8;
	S_VLA[25] = 8;
	S_VLA[26] = 16;
	S_VLA[27] = 20;
	S_VLA[28] = 16;
	S_VLA[29] = 20;
	S_VLA[30] = 20;
	S_VLA[31] = 8;
	S_VLA[32] = 20;
	S_VLA[33] = 8;
	S_VLA[34] = 28;
	S_VLA[35] = 20;
	S_VLA[36] = 28;
	S_VLA[37] = 20;
	S_VLA[38] = 32;
	S_VLA[39] = 8;
	S_VLA[40] = 32;
	S_VLA[41] = 4;
	S_VLA[42] = 20;
	S_VLA[43] = 8;
	S_VLA[44] = 20;
	S_VLA[45] = 8;
	S_VLA[46] = 28;
	S_VLA[47] = 4;
	S_VLA[48] = 28;
	S_VLA[49] = 20;
	S_VLA[50] = 8;
	S_VLA[51] = 24;
	S_VLA[52] = 8;
	S_VLA[53] = 24;
	S_VLA[54] = 16;
	S_VLA[55] = 20;
	S_VLA[56] = 16;

	T_VLA[0] = 4;
	T_VLA[1] = 4;
	T_VLA[2] = 24;
	T_VLA[3] = 8;
	T_VLA[4] = 24;
	T_VLA[5] = 8;
	T_VLA[6] = 32;
	T_VLA[7] = 4;
	T_VLA[8] = 32;
	T_VLA[9] = 20;
	T_VLA[10] = 24;
	T_VLA[11] = 24;
	T_VLA[12] = 24;
	T_VLA[13] = 24;
	T_VLA[14] = 32;
	T_VLA[15] = 20;
	T_VLA[16] = 32;
	T_VLA[17] = 8;
	T_VLA[18] = 28;
	T_VLA[19] = 20;
	T_VLA[20] = 28;
	T_VLA[21] = 20;
	T_VLA[22] = 32;
	T_VLA[23] = 8;
	T_VLA[24] = 32;
	T_VLA[25] = 12;
	T_VLA[26] = 4;
	T_VLA[27] = 16;
	T_VLA[28] = 4;
	T_VLA[29] = 16;
	T_VLA[30] = 28;
	T_VLA[31] = 12;
	T_VLA[32] = 28;

	U_VLA[0] = 3;
	U_VLA[1] = 4;
	U_VLA[2] = 8;
	U_VLA[3] = 8;
	U_VLA[4] = 8;
	U_VLA[5] = 8;
	U_VLA[6] = 32;
	U_VLA[7] = 4;
	U_VLA[8] = 32;
	U_VLA[9] = 20;
	U_VLA[10] = 8;
	U_VLA[11] = 24;
	U_VLA[12] = 8;
	U_VLA[13] = 24;
	U_VLA[14] = 32;
	U_VLA[15] = 20;
	U_VLA[16] = 32;
	U_VLA[17] = 8;
	U_VLA[18] = 4;
	U_VLA[19] = 20;
	U_VLA[20] = 4;
	U_VLA[21] = 20;
	U_VLA[22] = 8;
	U_VLA[23] = 8;
	U_VLA[24] = 8;

	V_VLA[0] = 5;
	V_VLA[1] = 4;
	V_VLA[2] = 20;
	V_VLA[3] = 8;
	V_VLA[4] = 20;
	V_VLA[5] = 8;
	V_VLA[6] = 32;
	V_VLA[7] = 4;
	V_VLA[8] = 32;
	V_VLA[9] = 20;
	V_VLA[10] = 20;
	V_VLA[11] = 24;
	V_VLA[12] = 20;
	V_VLA[13] = 24;
	V_VLA[14] = 32;
	V_VLA[15] = 20;
	V_VLA[16] = 32;
	V_VLA[17] = 8;
	V_VLA[18] = 12;
	V_VLA[19] = 12;
	V_VLA[20] = 12;
	V_VLA[21] = 12;
	V_VLA[22] = 20;
	V_VLA[23] = 8;
	V_VLA[24] = 20;
	V_VLA[25] = 16;
	V_VLA[26] = 12;
	V_VLA[27] = 20;
	V_VLA[28] = 12;
	V_VLA[29] = 20;
	V_VLA[30] = 20;
	V_VLA[31] = 16;
	V_VLA[32] = 20;
	V_VLA[33] = 12;
	V_VLA[34] = 4;
	V_VLA[35] = 16;
	V_VLA[36] = 4;
	V_VLA[37] = 16;
	V_VLA[38] = 12;
	V_VLA[39] = 12;
	V_VLA[40] = 12;

	W_VLA[0] = 5;
	W_VLA[1] = 4;
	W_VLA[2] = 4;
	W_VLA[3] = 8;
	W_VLA[4] = 4;
	W_VLA[5] = 8;
	W_VLA[6] = 32;
	W_VLA[7] = 4;
	W_VLA[8] = 32;
	W_VLA[9] = 20;
	W_VLA[10] = 4;
	W_VLA[11] = 24;
	W_VLA[12] = 4;
	W_VLA[13] = 24;
	W_VLA[14] = 32;
	W_VLA[15] = 20;
	W_VLA[16] = 32;
	W_VLA[17] = 8;
	W_VLA[18] = 8;
	W_VLA[19] = 12;
	W_VLA[20] = 8;
	W_VLA[21] = 12;
	W_VLA[22] = 12;
	W_VLA[23] = 8;
	W_VLA[24] = 12;
	W_VLA[25] = 16;
	W_VLA[26] = 8;
	W_VLA[27] = 20;
	W_VLA[28] = 8;
	W_VLA[29] = 20;
	W_VLA[30] = 12;
	W_VLA[31] = 16;
	W_VLA[32] = 12;
	W_VLA[33] = 12;
	W_VLA[34] = 12;
	W_VLA[35] = 16;
	W_VLA[36] = 12;
	W_VLA[37] = 16;
	W_VLA[38] = 20;
	W_VLA[39] = 12;
	W_VLA[40] = 20;

	X_VLA[0] = 9;
	X_VLA[1] = 4;
	X_VLA[2] = 4;
	X_VLA[3] = 8;
	X_VLA[4] = 4;
	X_VLA[5] = 8;
	X_VLA[6] = 12;
	X_VLA[7] = 4;
	X_VLA[8] = 12;
	X_VLA[9] = 20;
	X_VLA[10] = 4;
	X_VLA[11] = 24;
	X_VLA[12] = 4;
	X_VLA[13] = 24;
	X_VLA[14] = 12;
	X_VLA[15] = 20;
	X_VLA[16] = 12;
	X_VLA[17] = 4;
	X_VLA[18] = 24;
	X_VLA[19] = 8;
	X_VLA[20] = 24;
	X_VLA[21] = 8;
	X_VLA[22] = 32;
	X_VLA[23] = 4;
	X_VLA[24] = 32;
	X_VLA[25] = 20;
	X_VLA[26] = 24;
	X_VLA[27] = 24;
	X_VLA[28] = 24;
	X_VLA[29] = 24;
	X_VLA[30] = 32;
	X_VLA[31] = 20;
	X_VLA[32] = 32;
	X_VLA[33] = 8;
	X_VLA[34] = 12;
	X_VLA[35] = 12;
	X_VLA[36] = 12;
	X_VLA[37] = 12;
	X_VLA[38] = 16;
	X_VLA[39] = 8;
	X_VLA[40] = 16;
	X_VLA[41] = 16;
	X_VLA[42] = 12;
	X_VLA[43] = 20;
	X_VLA[44] = 12;
	X_VLA[45] = 20;
	X_VLA[46] = 16;
	X_VLA[47] = 16;
	X_VLA[48] = 16;
	X_VLA[49] = 12;
	X_VLA[50] = 16;
	X_VLA[51] = 16;
	X_VLA[52] = 16;
	X_VLA[53] = 16;
	X_VLA[54] = 20;
	X_VLA[55] = 12;
	X_VLA[56] = 20;
	X_VLA[57] = 8;
	X_VLA[58] = 20;
	X_VLA[59] = 12;
	X_VLA[60] = 20;
	X_VLA[61] = 12;
	X_VLA[62] = 24;
	X_VLA[63] = 8;
	X_VLA[64] = 24;
	X_VLA[65] = 16;
	X_VLA[66] = 20;
	X_VLA[67] = 20;
	X_VLA[68] = 20;
	X_VLA[69] = 20;
	X_VLA[70] = 24;
	X_VLA[71] = 16;
	X_VLA[72] = 24;

	Y_VLA[0] = 5;
	Y_VLA[1] = 12;
	Y_VLA[2] = 4;
	Y_VLA[3] = 16;
	Y_VLA[4] = 4;
	Y_VLA[5] = 16;
	Y_VLA[6] = 20;
	Y_VLA[7] = 12;
	Y_VLA[8] = 20;
	Y_VLA[9] = 8;
	Y_VLA[10] = 20;
	Y_VLA[11] = 12;
	Y_VLA[12] = 20;
	Y_VLA[13] = 12;
	Y_VLA[14] = 24;
	Y_VLA[15] = 8;
	Y_VLA[16] = 24;
	Y_VLA[17] = 16;
	Y_VLA[18] = 20;
	Y_VLA[19] = 20;
	Y_VLA[20] = 20;
	Y_VLA[21] = 20;
	Y_VLA[22] = 24;
	Y_VLA[23] = 16;
	Y_VLA[24] = 24;
	Y_VLA[25] = 4;
	Y_VLA[26] = 24;
	Y_VLA[27] = 8;
	Y_VLA[28] = 24;
	Y_VLA[29] = 8;
	Y_VLA[30] = 32;
	Y_VLA[31] = 4;
	Y_VLA[32] = 32;
	Y_VLA[33] = 20;
	Y_VLA[34] = 24;
	Y_VLA[35] = 24;
	Y_VLA[36] = 24;
	Y_VLA[37] = 24;
	Y_VLA[38] = 32;
	Y_VLA[39] = 20;
	Y_VLA[40] = 32;

	Z_VLA[0] = 7;
	Z_VLA[1] = 4;
	Z_VLA[2] = 4;
	Z_VLA[3] = 24;
	Z_VLA[4] = 4;
	Z_VLA[5] = 24;
	Z_VLA[6] = 8;
	Z_VLA[7] = 4;
	Z_VLA[8] = 8;
	Z_VLA[9] = 4;
	Z_VLA[10] = 28;
	Z_VLA[11] = 24;
	Z_VLA[12] = 28;
	Z_VLA[13] = 24;
	Z_VLA[14] = 32;
	Z_VLA[15] = 4;
	Z_VLA[16] = 32;
	Z_VLA[17] = 4;
	Z_VLA[18] = 8;
	Z_VLA[19] = 8;
	Z_VLA[20] = 8;
	Z_VLA[21] = 8;
	Z_VLA[22] = 12;
	Z_VLA[23] = 4;
	Z_VLA[24] = 12;
	Z_VLA[25] = 8;
	Z_VLA[26] = 12;
	Z_VLA[27] = 12;
	Z_VLA[28] = 12;
	Z_VLA[29] = 12;
	Z_VLA[30] = 16;
	Z_VLA[31] = 8;
	Z_VLA[32] = 16;
	Z_VLA[33] = 12;
	Z_VLA[34] = 16;
	Z_VLA[35] = 16;
	Z_VLA[36] = 16;
	Z_VLA[37] = 16;
	Z_VLA[38] = 20;
	Z_VLA[39] = 12;
	Z_VLA[40] = 20;
	Z_VLA[41] = 16;
	Z_VLA[42] = 20;
	Z_VLA[43] = 20;
	Z_VLA[44] = 20;
	Z_VLA[45] = 20;
	Z_VLA[46] = 24;
	Z_VLA[47] = 16;
	Z_VLA[48] = 24;
	Z_VLA[49] = 20;
	Z_VLA[50] = 24;
	Z_VLA[51] = 24;
	Z_VLA[52] = 24;
	Z_VLA[53] = 24;
	Z_VLA[54] = 28;
	Z_VLA[55] = 20;
	Z_VLA[56] = 28;

	PER_VLA[0] = 1;
	PER_VLA[1] = 12;
	PER_VLA[2] = 4;
	PER_VLA[3] = 16;
	PER_VLA[4] = 4;
	PER_VLA[5] = 16;
	PER_VLA[6] = 8;
	PER_VLA[7] = 12;
	PER_VLA[8] = 8;

	UND_VLA[0] = 1;
	UND_VLA[1] = 4;
	UND_VLA[2] = 4;
	UND_VLA[3] = 24;
	UND_VLA[4] = 4;
	UND_VLA[5] = 24;
	UND_VLA[6] = 8;
	UND_VLA[7] = 4;
	UND_VLA[8] = 8;

	EXP_VLA[0] = 2;
	EXP_VLA[1] = 12;
	EXP_VLA[2] = 4;
	EXP_VLA[3] = 16;
	EXP_VLA[4] = 4;
	EXP_VLA[5] = 16;
	EXP_VLA[6] = 8;
	EXP_VLA[7] = 12;
	EXP_VLA[8] = 8;
	EXP_VLA[9] = 12;
	EXP_VLA[10] = 16;
	EXP_VLA[11] = 16;
	EXP_VLA[12] = 16;
	EXP_VLA[13] = 16;
	EXP_VLA[14] = 32;
	EXP_VLA[15] = 12;
	EXP_VLA[16] = 32;

	QSM_VLA[0] = 6;
	QSM_VLA[1] = 12;
	QSM_VLA[2] = 4;
	QSM_VLA[3] = 16;
	QSM_VLA[4] = 4;
	QSM_VLA[5] = 16;
	QSM_VLA[6] = 8;
	QSM_VLA[7] = 12;
	QSM_VLA[8] = 8;
	QSM_VLA[9] = 12;
	QSM_VLA[10] = 12;
	QSM_VLA[11] = 16;
	QSM_VLA[12] = 12;
	QSM_VLA[13] = 16;
	QSM_VLA[14] = 20;
	QSM_VLA[15] = 12;
	QSM_VLA[16] = 20;
	QSM_VLA[17] = 16;
	QSM_VLA[18] = 16;
	QSM_VLA[19] = 20;
	QSM_VLA[20] = 16;
	QSM_VLA[21] = 20;
	QSM_VLA[22] = 20;
	QSM_VLA[23] = 16;
	QSM_VLA[24] = 20;
	QSM_VLA[25] = 20;
	QSM_VLA[26] = 20;
	QSM_VLA[27] = 24;
	QSM_VLA[28] = 20;
	QSM_VLA[29] = 24;
	QSM_VLA[30] = 28;
	QSM_VLA[31] = 20;
	QSM_VLA[32] = 28;
	QSM_VLA[33] = 4;
	QSM_VLA[34] = 24;
	QSM_VLA[35] = 8;
	QSM_VLA[36] = 24;
	QSM_VLA[37] = 8;
	QSM_VLA[38] = 28;
	QSM_VLA[39] = 4;
	QSM_VLA[40] = 28;
	QSM_VLA[41] = 8;
	QSM_VLA[42] = 28;
	QSM_VLA[43] = 20;
	QSM_VLA[44] = 28;
	QSM_VLA[45] = 20;
	QSM_VLA[46] = 32;
	QSM_VLA[47] = 8;
	QSM_VLA[48] = 32;

	SHL_VLA[0] = 1;
	SHL_VLA[1] = 28;
	SHL_VLA[2] = 16;
	SHL_VLA[3] = 32;
	SHL_VLA[4] = 16;
	SHL_VLA[5] = 32;
	SHL_VLA[6] = 24;
	SHL_VLA[7] = 28;
	SHL_VLA[8] = 24;

	SHR_VLA[0] = 4;
	SHR_VLA[1] = 0;
	SHR_VLA[2] = 12;
	SHR_VLA[3] = 4;
	SHR_VLA[4] = 12;
	SHR_VLA[5] = 4;
	SHR_VLA[6] = 28;
	SHR_VLA[7] = 0;
	SHR_VLA[8] = 28;
	SHR_VLA[9] = 8;
	SHR_VLA[10] = 12;
	SHR_VLA[11] = 12;
	SHR_VLA[12] = 12;
	SHR_VLA[13] = 12;
	SHR_VLA[14] = 28;
	SHR_VLA[15] = 8;
	SHR_VLA[16] = 28;
	SHR_VLA[17] = 4;
	SHR_VLA[18] = 8;
	SHR_VLA[19] = 8;
	SHR_VLA[20] = 8;
	SHR_VLA[21] = 8;
	SHR_VLA[22] = 24;
	SHR_VLA[23] = 4;
	SHR_VLA[24] = 24;
	SHR_VLA[25] = 12;
	SHR_VLA[26] = 16;
	SHR_VLA[27] = 16;
	SHR_VLA[28] = 16;
	SHR_VLA[29] = 16;
	SHR_VLA[30] = 24;
	SHR_VLA[31] = 12;
	SHR_VLA[32] = 24;

	LHL_VLA[0] = 2;
	LHL_VLA[1] = 24;
	LHL_VLA[2] = 16;
	LHL_VLA[3] = 28;
	LHL_VLA[4] = 16;
	LHL_VLA[5] = 28;
	LHL_VLA[6] = 24;
	LHL_VLA[7] = 24;
	LHL_VLA[8] = 24;
	LHL_VLA[9] = 28;
	LHL_VLA[10] = 12;
	LHL_VLA[11] = 32;
	LHL_VLA[12] = 12;
	LHL_VLA[13] = 32;
	LHL_VLA[14] = 28;
	LHL_VLA[15] = 28;
	LHL_VLA[16] = 28;

	LHR_VLA[0] = 5;
	LHR_VLA[1] = 0;
	LHR_VLA[2] = 8;
	LHR_VLA[3] = 4;
	LHR_VLA[4] = 8;
	LHR_VLA[5] = 4;
	LHR_VLA[6] = 28;
	LHR_VLA[7] = 0;
	LHR_VLA[8] = 28;
	LHR_VLA[9] = 4;
	LHR_VLA[10] = 4;
	LHR_VLA[11] = 8;
	LHR_VLA[12] = 4;
	LHR_VLA[13] = 8;
	LHR_VLA[14] = 24;
	LHR_VLA[15] = 4;
	LHR_VLA[16] = 24;
	LHR_VLA[17] = 8;
	LHR_VLA[18] = 8;
	LHR_VLA[19] = 12;
	LHR_VLA[20] = 8;
	LHR_VLA[21] = 12;
	LHR_VLA[22] = 28;
	LHR_VLA[23] = 8;
	LHR_VLA[24] = 28;
	LHR_VLA[25] = 12;
	LHR_VLA[26] = 12;
	LHR_VLA[27] = 16;
	LHR_VLA[28] = 12;
	LHR_VLA[29] = 16;
	LHR_VLA[30] = 28;
	LHR_VLA[31] = 12;
	LHR_VLA[32] = 28;
	LHR_VLA[33] = 16;
	LHR_VLA[34] = 16;
	LHR_VLA[35] = 20;
	LHR_VLA[36] = 16;
	LHR_VLA[37] = 20;
	LHR_VLA[38] = 24;
	LHR_VLA[39] = 16;
	LHR_VLA[40] = 24;

	AZ_VLA[1] = A_VLA;
	AZ_VLA[2] = B_VLA;
	AZ_VLA[3] = C_VLA;
	AZ_VLA[4] = D_VLA;
	AZ_VLA[5] = E_VLA;
	AZ_VLA[6] = F_VLA;
	AZ_VLA[7] = G_VLA;
	AZ_VLA[8] = H_VLA;
	AZ_VLA[9] = I_VLA;
	AZ_VLA[10] = J_VLA;
	AZ_VLA[11] = K_VLA;
	AZ_VLA[12] = L_VLA;
	AZ_VLA[13] = M_VLA;
	AZ_VLA[14] = N_VLA;
	AZ_VLA[15] = O_VLA;
	AZ_VLA[16] = P_VLA;
	AZ_VLA[17] = Q_VLA;
	AZ_VLA[18] = R_VLA;
	AZ_VLA[19] = S_VLA;
	AZ_VLA[20] = T_VLA;
	AZ_VLA[21] = U_VLA;
	AZ_VLA[22] = V_VLA;
	AZ_VLA[23] = W_VLA;
	AZ_VLA[24] = X_VLA;
	AZ_VLA[25] = Y_VLA;
	AZ_VLA[26] = Z_VLA;
	AZ_VLA[27] = PER_VLA;
	AZ_VLA[28] = UND_VLA;
	AZ_VLA[29] = EXP_VLA;
	AZ_VLA[30] = QSM_VLA;
	AZ_VLA[31] = SHL_VLA;
	AZ_VLA[32] = SHR_VLA;
	AZ_VLA[33] = LHL_VLA;
	AZ_VLA[34] = LHR_VLA;

	SP_VLA[0] = 2;
	SP_VLA[1] = 11;
	SP_VLA[2] = 160;
	SP_VLA[3] = 124;
	SP_VLA[4] = 164;
	SP_VLA[5] = 116;
	SP_VLA[6] = 168;
	SP_VLA[7] = 120;
	SP_VLA[8] = 176;
	SP_VLA[9] = 116;
	SP_VLA[10] = 184;
	SP_VLA[11] = 120;
	SP_VLA[12] = 176;
	SP_VLA[13] = 124;
	SP_VLA[14] = 168;
	SP_VLA[15] = 120;
	SP_VLA[16] = 176;
	SP_VLA[17] = 120;
	SP_VLA[18] = 184;
	SP_VLA[19] = 120;
	SP_VLA[20] = 188;
	SP_VLA[21] = 116;
	SP_VLA[22] = 192;
	SP_VLA[23] = 124;
	SP_VLA[24] = 7;
	SP_VLA[25] = 168;
	SP_VLA[26] = 124;
	SP_VLA[27] = 170;
	SP_VLA[28] = 116;
	SP_VLA[29] = 172;
	SP_VLA[30] = 120;
	SP_VLA[31] = 176;
	SP_VLA[32] = 122;
	SP_VLA[33] = 180;
	SP_VLA[34] = 120;
	SP_VLA[35] = 182;
	SP_VLA[36] = 116;
	SP_VLA[37] = 184;
	SP_VLA[38] = 124;

	WR_VLA[0] = 3;
	WR_VLA[1] = 3;
	WR_VLA[2] = 68;
	WR_VLA[3] = 62;
	WR_VLA[4] = 88;
	WR_VLA[5] = 68;
	WR_VLA[6] = 100;
	WR_VLA[7] = 56;
	WR_VLA[8] = 9;
	WR_VLA[9] = 90;
	WR_VLA[10] = 74;
	WR_VLA[11] = 74;
	WR_VLA[12] = 70;
	WR_VLA[13] = 80;
	WR_VLA[14] = 76;
	WR_VLA[15] = 90;
	WR_VLA[16] = 74;
	WR_VLA[17] = 100;
	WR_VLA[18] = 72;
	WR_VLA[19] = 102;
	WR_VLA[20] = 64;
	WR_VLA[21] = 90;
	WR_VLA[22] = 74;
	WR_VLA[23] = 94;
	WR_VLA[24] = 86;
	WR_VLA[25] = 90;
	WR_VLA[26] = 86;
	WR_VLA[27] = 7;
	WR_VLA[28] = 80;
	WR_VLA[29] = 100;
	WR_VLA[30] = 86;
	WR_VLA[31] = 90;
	WR_VLA[32] = 100;
	WR_VLA[33] = 92;
	WR_VLA[34] = 108;
	WR_VLA[35] = 98;
	WR_VLA[36] = 98;
	WR_VLA[37] = 94;
	WR_VLA[38] = 86;
	WR_VLA[39] = 94;
	WR_VLA[40] = 80;
	WR_VLA[41] = 100;

	SC_VLA[0] = 2;
	SC_VLA[1] = 13;
	SC_VLA[2] = 74;
	SC_VLA[3] = 112;
	SC_VLA[4] = 74;
	SC_VLA[5] = 108;
	SC_VLA[6] = 70;
	SC_VLA[7] = 104;
	SC_VLA[8] = 62;
	SC_VLA[9] = 108;
	SC_VLA[10] = 66;
	SC_VLA[11] = 116;
	SC_VLA[12] = 74;
	SC_VLA[13] = 118;
	SC_VLA[14] = 82;
	SC_VLA[15] = 120;
	SC_VLA[16] = 82;
	SC_VLA[17] = 124;
	SC_VLA[18] = 74;
	SC_VLA[19] = 124;
	SC_VLA[20] = 66;
	SC_VLA[21] = 116;
	SC_VLA[22] = 70;
	SC_VLA[23] = 120;
	SC_VLA[24] = 62;
	SC_VLA[25] = 120;
	SC_VLA[26] = 66;
	SC_VLA[27] = 124;
	SC_VLA[28] = 6;
	SC_VLA[29] = 90;
	SC_VLA[30] = 124;
	SC_VLA[31] = 90;
	SC_VLA[32] = 120;
	SC_VLA[33] = 82;
	SC_VLA[34] = 120;
	SC_VLA[35] = 74;
	SC_VLA[36] = 124;
	SC_VLA[37] = 74;
	SC_VLA[38] = 128;
	SC_VLA[39] = 82;
	SC_VLA[40] = 128;

	BL_VLA[0] = 3;
	BL_VLA[1] = 20;
	BL_VLA[2] = 130;
	BL_VLA[3] = 82;
	BL_VLA[4] = 114;
	BL_VLA[5] = 86;
	BL_VLA[6] = 108;
	BL_VLA[7] = 100;
	BL_VLA[8] = 106;
	BL_VLA[9] = 110;
	BL_VLA[10] = 106;
	BL_VLA[11] = 120;
	BL_VLA[12] = 96;
	BL_VLA[13] = 130;
	BL_VLA[14] = 106;
	BL_VLA[15] = 128;
	BL_VLA[16] = 104;
	BL_VLA[17] = 132;
	BL_VLA[18] = 114;
	BL_VLA[19] = 126;
	BL_VLA[20] = 128;
	BL_VLA[21] = 128;
	BL_VLA[22] = 142;
	BL_VLA[23] = 130;
	BL_VLA[24] = 148;
	BL_VLA[25] = 128;
	BL_VLA[26] = 152;
	BL_VLA[27] = 132;
	BL_VLA[28] = 154;
	BL_VLA[29] = 128;
	BL_VLA[30] = 162;
	BL_VLA[31] = 130;
	BL_VLA[32] = 156;
	BL_VLA[33] = 124;
	BL_VLA[34] = 154;
	BL_VLA[35] = 108;
	BL_VLA[36] = 148;
	BL_VLA[37] = 92;
	BL_VLA[38] = 138;
	BL_VLA[39] = 86;
	BL_VLA[40] = 130;
	BL_VLA[41] = 82;
	BL_VLA[42] = 8;
	BL_VLA[43] = 130;
	BL_VLA[44] = 86;
	BL_VLA[45] = 136;
	BL_VLA[46] = 92;
	BL_VLA[47] = 138;
	BL_VLA[48] = 98;
	BL_VLA[49] = 128;
	BL_VLA[50] = 100;
	BL_VLA[51] = 130;
	BL_VLA[52] = 86;
	BL_VLA[53] = 120;
	BL_VLA[54] = 92;
	BL_VLA[55] = 118;
	BL_VLA[56] = 102;
	BL_VLA[57] = 128;
	BL_VLA[58] = 100;
	BL_VLA[59] = 3;
	BL_VLA[60] = 116;
	BL_VLA[61] = 108;
	BL_VLA[62] = 118;
	BL_VLA[63] = 114;
	BL_VLA[64] = 144;
	BL_VLA[65] = 120;

	GL_VLA[0] = 4;
	GL_VLA[1] = 21;
	GL_VLA[2] = 124;
	GL_VLA[3] = 80;
	GL_VLA[4] = 114;
	GL_VLA[5] = 94;
	GL_VLA[6] = 120;
	GL_VLA[7] = 110;
	GL_VLA[8] = 112;
	GL_VLA[9] = 132;
	GL_VLA[10] = 78;
	GL_VLA[11] = 104;
	GL_VLA[12] = 48;
	GL_VLA[13] = 132;
	GL_VLA[14] = 72;
	GL_VLA[15] = 68;
	GL_VLA[16] = 32;
	GL_VLA[17] = 84;
	GL_VLA[18] = 88;
	GL_VLA[19] = 22;
	GL_VLA[20] = 114;
	GL_VLA[21] = 52;
	GL_VLA[22] = 128;
	GL_VLA[23] = 92;
	GL_VLA[24] = 142;
	GL_VLA[25] = 52;
	GL_VLA[26] = 168;
	GL_VLA[27] = 22;
	GL_VLA[28] = 224;
	GL_VLA[29] = 88;
	GL_VLA[30] = 184;
	GL_VLA[31] = 68;
	GL_VLA[32] = 208;
	GL_VLA[33] = 132;
	GL_VLA[34] = 178;
	GL_VLA[35] = 112;
	GL_VLA[36] = 144;
	GL_VLA[37] = 132;
	GL_VLA[38] = 136;
	GL_VLA[39] = 110;
	GL_VLA[40] = 142;
	GL_VLA[41] = 94;
	GL_VLA[42] = 132;
	GL_VLA[43] = 80;
	GL_VLA[44] = 9;
	GL_VLA[45] = 112;
	GL_VLA[46] = 132;
	GL_VLA[47] = 122;
	GL_VLA[48] = 124;
	GL_VLA[49] = 126;
	GL_VLA[50] = 110;
	GL_VLA[51] = 122;
	GL_VLA[52] = 100;
	GL_VLA[53] = 128;
	GL_VLA[54] = 92;
	GL_VLA[55] = 134;
	GL_VLA[56] = 100;
	GL_VLA[57] = 130;
	GL_VLA[58] = 110;
	GL_VLA[59] = 134;
	GL_VLA[60] = 124;
	GL_VLA[61] = 144;
	GL_VLA[62] = 132;
	GL_VLA[63] = 11;
	GL_VLA[64] = 122;
	GL_VLA[65] = 82;
	GL_VLA[66] = 106;
	GL_VLA[67] = 96;
	GL_VLA[68] = 92;
	GL_VLA[69] = 92;
	GL_VLA[70] = 86;
	GL_VLA[71] = 76;
	GL_VLA[72] = 78;
	GL_VLA[73] = 72;
	GL_VLA[74] = 84;
	GL_VLA[75] = 78;
	GL_VLA[76] = 76;
	GL_VLA[77] = 78;
	GL_VLA[78] = 84;
	GL_VLA[79] = 82;
	GL_VLA[80] = 88;
	GL_VLA[81] = 96;
	GL_VLA[82] = 102;
	GL_VLA[83] = 104;
	GL_VLA[84] = 116;
	GL_VLA[85] = 100;
	GL_VLA[86] = 27;
	GL_VLA[87] = 168;
	GL_VLA[88] = 22;
	GL_VLA[89] = 162;
	GL_VLA[90] = 26;
	GL_VLA[91] = 166;
	GL_VLA[92] = 18;
	GL_VLA[93] = 160;
	GL_VLA[94] = 24;
	GL_VLA[95] = 160;
	GL_VLA[96] = 30;
	GL_VLA[97] = 150;
	GL_VLA[98] = 38;
	GL_VLA[99] = 140;
	GL_VLA[100] = 46;
	GL_VLA[101] = 134;
	GL_VLA[102] = 42;
	GL_VLA[103] = 138;
	GL_VLA[104] = 32;
	GL_VLA[105] = 132;
	GL_VLA[106] = 18;
	GL_VLA[107] = 134;
	GL_VLA[108] = 32;
	GL_VLA[109] = 128;
	GL_VLA[110] = 38;
	GL_VLA[111] = 122;
	GL_VLA[112] = 32;
	GL_VLA[113] = 124;
	GL_VLA[114] = 18;
	GL_VLA[115] = 118;
	GL_VLA[116] = 32;
	GL_VLA[117] = 122;
	GL_VLA[118] = 42;
	GL_VLA[119] = 128;
	GL_VLA[120] = 54;
	GL_VLA[121] = 134;
	GL_VLA[122] = 42;
	GL_VLA[123] = 128;
	GL_VLA[124] = 46;
	GL_VLA[125] = 122;
	GL_VLA[126] = 42;
	GL_VLA[127] = 116;
	GL_VLA[128] = 46;
	GL_VLA[129] = 106;
	GL_VLA[130] = 38;
	GL_VLA[131] = 96;
	GL_VLA[132] = 30;
	GL_VLA[133] = 96;
	GL_VLA[134] = 24;
	GL_VLA[135] = 90;
	GL_VLA[136] = 18;
	GL_VLA[137] = 94;
	GL_VLA[138] = 26;
	GL_VLA[139] = 88;
	GL_VLA[140] = 22;

	VI_VLA[0] = 2;
	VI_VLA[1] = 15;
	VI_VLA[2] = 130;
	VI_VLA[3] = 132;
	VI_VLA[4] = 122;
	VI_VLA[5] = 112;
	VI_VLA[6] = 124;
	VI_VLA[7] = 92;
	VI_VLA[8] = 126;
	VI_VLA[9] = 94;
	VI_VLA[10] = 130;
	VI_VLA[11] = 94;
	VI_VLA[12] = 132;
	VI_VLA[13] = 92;
	VI_VLA[14] = 130;
	VI_VLA[15] = 112;
	VI_VLA[16] = 140;
	VI_VLA[17] = 128;
	VI_VLA[18] = 136;
	VI_VLA[19] = 132;
	VI_VLA[20] = 114;
	VI_VLA[21] = 132;
	VI_VLA[22] = 108;
	VI_VLA[23] = 120;
	VI_VLA[24] = 118;
	VI_VLA[25] = 106;
	VI_VLA[26] = 112;
	VI_VLA[27] = 120;
	VI_VLA[28] = 116;
	VI_VLA[29] = 124;
	VI_VLA[30] = 126;
	VI_VLA[31] = 124;
	VI_VLA[32] = 16;
	VI_VLA[33] = 120;
	VI_VLA[34] = 100;
	VI_VLA[35] = 120;
	VI_VLA[36] = 96;
	VI_VLA[37] = 124;
	VI_VLA[38] = 92;
	VI_VLA[39] = 120;
	VI_VLA[40] = 88;
	VI_VLA[41] = 120;
	VI_VLA[42] = 84;
	VI_VLA[43] = 122;
	VI_VLA[44] = 82;
	VI_VLA[45] = 126;
	VI_VLA[46] = 86;
	VI_VLA[47] = 122;
	VI_VLA[48] = 82;
	VI_VLA[49] = 134;
	VI_VLA[50] = 82;
	VI_VLA[51] = 130;
	VI_VLA[52] = 86;
	VI_VLA[53] = 134;
	VI_VLA[54] = 82;
	VI_VLA[55] = 136;
	VI_VLA[56] = 84;
	VI_VLA[57] = 136;
	VI_VLA[58] = 88;
	VI_VLA[59] = 132;
	VI_VLA[60] = 92;
	VI_VLA[61] = 136;
	VI_VLA[62] = 96;
	VI_VLA[63] = 136;
	VI_VLA[64] = 100;

	S1_VLA[0] = 5;
	S1_VLA[1] = 10;
	S1_VLA[2] = 98;
	S1_VLA[3] = 104;
	S1_VLA[4] = 112;
	S1_VLA[5] = 98;
	S1_VLA[6] = 120;
	S1_VLA[7] = 92;
	S1_VLA[8] = 128;
	S1_VLA[9] = 94;
	S1_VLA[10] = 132;
	S1_VLA[11] = 96;
	S1_VLA[12] = 132;
	S1_VLA[13] = 102;
	S1_VLA[14] = 126;
	S1_VLA[15] = 104;
	S1_VLA[16] = 120;
	S1_VLA[17] = 104;
	S1_VLA[18] = 114;
	S1_VLA[19] = 102;
	S1_VLA[20] = 100;
	S1_VLA[21] = 106;
	S1_VLA[22] = 12;
	S1_VLA[23] = 132;
	S1_VLA[24] = 102;
	S1_VLA[25] = 136;
	S1_VLA[26] = 102;
	S1_VLA[27] = 148;
	S1_VLA[28] = 112;
	S1_VLA[29] = 160;
	S1_VLA[30] = 122;
	S1_VLA[31] = 174;
	S1_VLA[32] = 124;
	S1_VLA[33] = 170;
	S1_VLA[34] = 120;
	S1_VLA[35] = 174;
	S1_VLA[36] = 120;
	S1_VLA[37] = 162;
	S1_VLA[38] = 116;
	S1_VLA[39] = 152;
	S1_VLA[40] = 106;
	S1_VLA[41] = 142;
	S1_VLA[42] = 96;
	S1_VLA[43] = 130;
	S1_VLA[44] = 92;
	S1_VLA[45] = 118;
	S1_VLA[46] = 88;
	S1_VLA[47] = 8;
	S1_VLA[48] = 92;
	S1_VLA[49] = 78;
	S1_VLA[50] = 96;
	S1_VLA[51] = 70;
	S1_VLA[52] = 98;
	S1_VLA[53] = 80;
	S1_VLA[54] = 94;
	S1_VLA[55] = 86;
	S1_VLA[56] = 92;
	S1_VLA[57] = 78;
	S1_VLA[58] = 84;
	S1_VLA[59] = 76;
	S1_VLA[60] = 88;
	S1_VLA[61] = 84;
	S1_VLA[62] = 94;
	S1_VLA[63] = 86;
	S1_VLA[64] = 11;
	S1_VLA[65] = 90;
	S1_VLA[66] = 106;
	S1_VLA[67] = 86;
	S1_VLA[68] = 108;
	S1_VLA[69] = 88;
	S1_VLA[70] = 110;
	S1_VLA[71] = 94;
	S1_VLA[72] = 108;
	S1_VLA[73] = 98;
	S1_VLA[74] = 120;
	S1_VLA[75] = 84;
	S1_VLA[76] = 126;
	S1_VLA[77] = 88;
	S1_VLA[78] = 122;
	S1_VLA[79] = 80;
	S1_VLA[80] = 122;
	S1_VLA[81] = 88;
	S1_VLA[82] = 118;
	S1_VLA[83] = 76;
	S1_VLA[84] = 102;
	S1_VLA[85] = 80;
	S1_VLA[86] = 98;
	S1_VLA[87] = 21;
	S1_VLA[88] = 84;
	S1_VLA[89] = 86;
	S1_VLA[90] = 92;
	S1_VLA[91] = 96;
	S1_VLA[92] = 102;
	S1_VLA[93] = 108;
	S1_VLA[94] = 98;
	S1_VLA[95] = 112;
	S1_VLA[96] = 86;
	S1_VLA[97] = 104;
	S1_VLA[98] = 74;
	S1_VLA[99] = 94;
	S1_VLA[100] = 76;
	S1_VLA[101] = 82;
	S1_VLA[102] = 84;
	S1_VLA[103] = 76;
	S1_VLA[104] = 80;
	S1_VLA[105] = 72;
	S1_VLA[106] = 84;
	S1_VLA[107] = 74;
	S1_VLA[108] = 88;
	S1_VLA[109] = 68;
	S1_VLA[110] = 94;
	S1_VLA[111] = 70;
	S1_VLA[112] = 96;
	S1_VLA[113] = 66;
	S1_VLA[114] = 96;
	S1_VLA[115] = 70;
	S1_VLA[116] = 108;
	S1_VLA[117] = 68;
	S1_VLA[118] = 116;
	S1_VLA[119] = 72;
	S1_VLA[120] = 120;
	S1_VLA[121] = 86;
	S1_VLA[122] = 104;
	S1_VLA[123] = 96;
	S1_VLA[124] = 100;
	S1_VLA[125] = 92;
	S1_VLA[126] = 110;
	S1_VLA[127] = 84;
	S1_VLA[128] = 106;
	S1_VLA[129] = 74;

	S2_VLA[0] = 5;
	S2_VLA[1] = 4;
	S2_VLA[2] = 98;
	S2_VLA[3] = 104;
	S2_VLA[4] = 124;
	S2_VLA[5] = 94;
	S2_VLA[6] = 126;
	S2_VLA[7] = 96;
	S2_VLA[8] = 100;
	S2_VLA[9] = 106;
	S2_VLA[10] = 16;
	S2_VLA[11] = 132;
	S2_VLA[12] = 102;
	S2_VLA[13] = 114;
	S2_VLA[14] = 92;
	S2_VLA[15] = 118;
	S2_VLA[16] = 102;
	S2_VLA[17] = 114;
	S2_VLA[18] = 110;
	S2_VLA[19] = 132;
	S2_VLA[20] = 102;
	S2_VLA[21] = 136;
	S2_VLA[22] = 102;
	S2_VLA[23] = 148;
	S2_VLA[24] = 112;
	S2_VLA[25] = 160;
	S2_VLA[26] = 122;
	S2_VLA[27] = 174;
	S2_VLA[28] = 124;
	S2_VLA[29] = 170;
	S2_VLA[30] = 120;
	S2_VLA[31] = 174;
	S2_VLA[32] = 120;
	S2_VLA[33] = 162;
	S2_VLA[34] = 116;
	S2_VLA[35] = 152;
	S2_VLA[36] = 106;
	S2_VLA[37] = 142;
	S2_VLA[38] = 96;
	S2_VLA[39] = 130;
	S2_VLA[40] = 92;
	S2_VLA[41] = 118;
	S2_VLA[42] = 88;
	S2_VLA[43] = 8;
	S2_VLA[44] = 92;
	S2_VLA[45] = 78;
	S2_VLA[46] = 96;
	S2_VLA[47] = 70;
	S2_VLA[48] = 98;
	S2_VLA[49] = 80;
	S2_VLA[50] = 94;
	S2_VLA[51] = 86;
	S2_VLA[52] = 92;
	S2_VLA[53] = 78;
	S2_VLA[54] = 84;
	S2_VLA[55] = 76;
	S2_VLA[56] = 88;
	S2_VLA[57] = 84;
	S2_VLA[58] = 94;
	S2_VLA[59] = 86;
	S2_VLA[60] = 11;
	S2_VLA[61] = 90;
	S2_VLA[62] = 106;
	S2_VLA[63] = 86;
	S2_VLA[64] = 108;
	S2_VLA[65] = 88;
	S2_VLA[66] = 110;
	S2_VLA[67] = 94;
	S2_VLA[68] = 108;
	S2_VLA[69] = 98;
	S2_VLA[70] = 120;
	S2_VLA[71] = 84;
	S2_VLA[72] = 126;
	S2_VLA[73] = 88;
	S2_VLA[74] = 122;
	S2_VLA[75] = 80;
	S2_VLA[76] = 122;
	S2_VLA[77] = 88;
	S2_VLA[78] = 118;
	S2_VLA[79] = 76;
	S2_VLA[80] = 102;
	S2_VLA[81] = 80;
	S2_VLA[82] = 98;
	S2_VLA[83] = 21;
	S2_VLA[84] = 84;
	S2_VLA[85] = 86;
	S2_VLA[86] = 92;
	S2_VLA[87] = 96;
	S2_VLA[88] = 102;
	S2_VLA[89] = 108;
	S2_VLA[90] = 98;
	S2_VLA[91] = 112;
	S2_VLA[92] = 86;
	S2_VLA[93] = 104;
	S2_VLA[94] = 74;
	S2_VLA[95] = 94;
	S2_VLA[96] = 76;
	S2_VLA[97] = 82;
	S2_VLA[98] = 84;
	S2_VLA[99] = 76;
	S2_VLA[100] = 80;
	S2_VLA[101] = 72;
	S2_VLA[102] = 84;
	S2_VLA[103] = 74;
	S2_VLA[104] = 88;
	S2_VLA[105] = 68;
	S2_VLA[106] = 94;
	S2_VLA[107] = 70;
	S2_VLA[108] = 96;
	S2_VLA[109] = 66;
	S2_VLA[110] = 96;
	S2_VLA[111] = 70;
	S2_VLA[112] = 108;
	S2_VLA[113] = 68;
	S2_VLA[114] = 116;
	S2_VLA[115] = 72;
	S2_VLA[116] = 120;
	S2_VLA[117] = 86;
	S2_VLA[118] = 104;
	S2_VLA[119] = 96;
	S2_VLA[120] = 100;
	S2_VLA[121] = 92;
	S2_VLA[122] = 110;
	S2_VLA[123] = 84;
	S2_VLA[124] = 106;
	S2_VLA[125] = 74;

	K1_VLA[0] = 8;
	K1_VLA[1] = 5;
	K1_VLA[2] = 124;
	K1_VLA[3] = 34;
	K1_VLA[4] = 132;
	K1_VLA[5] = 34;
	K1_VLA[6] = 130;
	K1_VLA[7] = 36;
	K1_VLA[8] = 126;
	K1_VLA[9] = 36;
	K1_VLA[10] = 124;
	K1_VLA[11] = 34;
	K1_VLA[12] = 8;
	K1_VLA[13] = 142;
	K1_VLA[14] = 80;
	K1_VLA[15] = 136;
	K1_VLA[16] = 64;
	K1_VLA[17] = 146;
	K1_VLA[18] = 46;
	K1_VLA[19] = 156;
	K1_VLA[20] = 64;
	K1_VLA[21] = 140;
	K1_VLA[22] = 82;
	K1_VLA[23] = 136;
	K1_VLA[24] = 76;
	K1_VLA[25] = 146;
	K1_VLA[26] = 64;
	K1_VLA[27] = 140;
	K1_VLA[28] = 58;
	K1_VLA[29] = 6;
	K1_VLA[30] = 140;
	K1_VLA[31] = 80;
	K1_VLA[32] = 152;
	K1_VLA[33] = 128;
	K1_VLA[34] = 160;
	K1_VLA[35] = 132;
	K1_VLA[36] = 144;
	K1_VLA[37] = 132;
	K1_VLA[38] = 144;
	K1_VLA[39] = 126;
	K1_VLA[40] = 130;
	K1_VLA[41] = 84;
	K1_VLA[42] = 6;
	K1_VLA[43] = 126;
	K1_VLA[44] = 84;
	K1_VLA[45] = 110;
	K1_VLA[46] = 126;
	K1_VLA[47] = 110;
	K1_VLA[48] = 132;
	K1_VLA[49] = 92;
	K1_VLA[50] = 132;
	K1_VLA[51] = 102;
	K1_VLA[52] = 128;
	K1_VLA[53] = 116;
	K1_VLA[54] = 80;
	K1_VLA[55] = 17;
	K1_VLA[56] = 140;
	K1_VLA[57] = 80;
	K1_VLA[58] = 128;
	K1_VLA[59] = 86;
	K1_VLA[60] = 114;
	K1_VLA[61] = 80;
	K1_VLA[62] = 120;
	K1_VLA[63] = 64;
	K1_VLA[64] = 116;
	K1_VLA[65] = 58;
	K1_VLA[66] = 110;
	K1_VLA[67] = 46;
	K1_VLA[68] = 122;
	K1_VLA[69] = 42;
	K1_VLA[70] = 124;
	K1_VLA[71] = 30;
	K1_VLA[72] = 128;
	K1_VLA[73] = 26;
	K1_VLA[74] = 132;
	K1_VLA[75] = 30;
	K1_VLA[76] = 134;
	K1_VLA[77] = 42;
	K1_VLA[78] = 146;
	K1_VLA[79] = 46;
	K1_VLA[80] = 134;
	K1_VLA[81] = 42;
	K1_VLA[82] = 134;
	K1_VLA[83] = 46;
	K1_VLA[84] = 128;
	K1_VLA[85] = 52;
	K1_VLA[86] = 122;
	K1_VLA[87] = 46;
	K1_VLA[88] = 122;
	K1_VLA[89] = 42;
	K1_VLA[90] = 7;
	K1_VLA[91] = 128;
	K1_VLA[92] = 52;
	K1_VLA[93] = 128;
	K1_VLA[94] = 20;
	K1_VLA[95] = 124;
	K1_VLA[96] = 20;
	K1_VLA[97] = 126;
	K1_VLA[98] = 24;
	K1_VLA[99] = 130;
	K1_VLA[100] = 24;
	K1_VLA[101] = 132;
	K1_VLA[102] = 20;
	K1_VLA[103] = 128;
	K1_VLA[104] = 20;
	K1_VLA[105] = 14;
	K1_VLA[106] = 102;
	K1_VLA[107] = 74;
	K1_VLA[108] = 102;
	K1_VLA[109] = 70;
	K1_VLA[110] = 106;
	K1_VLA[111] = 70;
	K1_VLA[112] = 106;
	K1_VLA[113] = 64;
	K1_VLA[114] = 90;
	K1_VLA[115] = 64;
	K1_VLA[116] = 90;
	K1_VLA[117] = 70;
	K1_VLA[118] = 94;
	K1_VLA[119] = 70;
	K1_VLA[120] = 94;
	K1_VLA[121] = 74;
	K1_VLA[122] = 96;
	K1_VLA[123] = 74;
	K1_VLA[124] = 96;
	K1_VLA[125] = 80;
	K1_VLA[126] = 100;
	K1_VLA[127] = 80;
	K1_VLA[128] = 100;
	K1_VLA[129] = 74;
	K1_VLA[130] = 102;
	K1_VLA[131] = 74;
	K1_VLA[132] = 116;
	K1_VLA[133] = 58;
	K1_VLA[134] = 9;
	K1_VLA[135] = 110;
	K1_VLA[136] = 46;
	K1_VLA[137] = 102;
	K1_VLA[138] = 64;
	K1_VLA[139] = 100;
	K1_VLA[140] = 64;
	K1_VLA[141] = 102;
	K1_VLA[142] = 30;
	K1_VLA[143] = 98;
	K1_VLA[144] = 20;
	K1_VLA[145] = 94;
	K1_VLA[146] = 30;
	K1_VLA[147] = 96;
	K1_VLA[148] = 64;
	K1_VLA[149] = 98;
	K1_VLA[150] = 64;
	K1_VLA[151] = 98;
	K1_VLA[152] = 20;

	K2_VLA[0] = 8;
	K2_VLA[1] = 4;
	K2_VLA[2] = 126;
	K2_VLA[3] = 30;
	K2_VLA[4] = 126;
	K2_VLA[5] = 40;
	K2_VLA[6] = 124;
	K2_VLA[7] = 40;
	K2_VLA[8] = 124;
	K2_VLA[9] = 36;
	K2_VLA[10] = 7;
	K2_VLA[11] = 150;
	K2_VLA[12] = 44;
	K2_VLA[13] = 166;
	K2_VLA[14] = 52;
	K2_VLA[15] = 164;
	K2_VLA[16] = 76;
	K2_VLA[17] = 150;
	K2_VLA[18] = 92;
	K2_VLA[19] = 136;
	K2_VLA[20] = 76;
	K2_VLA[21] = 134;
	K2_VLA[22] = 52;
	K2_VLA[23] = 150;
	K2_VLA[24] = 44;
	K2_VLA[25] = 6;
	K2_VLA[26] = 140;
	K2_VLA[27] = 80;
	K2_VLA[28] = 152;
	K2_VLA[29] = 128;
	K2_VLA[30] = 160;
	K2_VLA[31] = 132;
	K2_VLA[32] = 144;
	K2_VLA[33] = 132;
	K2_VLA[34] = 144;
	K2_VLA[35] = 126;
	K2_VLA[36] = 130;
	K2_VLA[37] = 84;
	K2_VLA[38] = 6;
	K2_VLA[39] = 126;
	K2_VLA[40] = 84;
	K2_VLA[41] = 110;
	K2_VLA[42] = 126;
	K2_VLA[43] = 110;
	K2_VLA[44] = 132;
	K2_VLA[45] = 92;
	K2_VLA[46] = 132;
	K2_VLA[47] = 102;
	K2_VLA[48] = 128;
	K2_VLA[49] = 116;
	K2_VLA[50] = 80;
	K2_VLA[51] = 17;
	K2_VLA[52] = 140;
	K2_VLA[53] = 80;
	K2_VLA[54] = 128;
	K2_VLA[55] = 86;
	K2_VLA[56] = 114;
	K2_VLA[57] = 80;
	K2_VLA[58] = 120;
	K2_VLA[59] = 64;
	K2_VLA[60] = 116;
	K2_VLA[61] = 58;
	K2_VLA[62] = 110;
	K2_VLA[63] = 46;
	K2_VLA[64] = 122;
	K2_VLA[65] = 42;
	K2_VLA[66] = 124;
	K2_VLA[67] = 30;
	K2_VLA[68] = 128;
	K2_VLA[69] = 26;
	K2_VLA[70] = 132;
	K2_VLA[71] = 30;
	K2_VLA[72] = 134;
	K2_VLA[73] = 42;
	K2_VLA[74] = 146;
	K2_VLA[75] = 46;
	K2_VLA[76] = 134;
	K2_VLA[77] = 42;
	K2_VLA[78] = 134;
	K2_VLA[79] = 46;
	K2_VLA[80] = 128;
	K2_VLA[81] = 52;
	K2_VLA[82] = 122;
	K2_VLA[83] = 46;
	K2_VLA[84] = 122;
	K2_VLA[85] = 42;
	K2_VLA[86] = 7;
	K2_VLA[87] = 128;
	K2_VLA[88] = 52;
	K2_VLA[89] = 128;
	K2_VLA[90] = 20;
	K2_VLA[91] = 124;
	K2_VLA[92] = 20;
	K2_VLA[93] = 126;
	K2_VLA[94] = 24;
	K2_VLA[95] = 130;
	K2_VLA[96] = 24;
	K2_VLA[97] = 132;
	K2_VLA[98] = 20;
	K2_VLA[99] = 128;
	K2_VLA[100] = 20;
	K2_VLA[101] = 14;
	K2_VLA[102] = 102;
	K2_VLA[103] = 74;
	K2_VLA[104] = 102;
	K2_VLA[105] = 70;
	K2_VLA[106] = 106;
	K2_VLA[107] = 70;
	K2_VLA[108] = 106;
	K2_VLA[109] = 64;
	K2_VLA[110] = 90;
	K2_VLA[111] = 64;
	K2_VLA[112] = 90;
	K2_VLA[113] = 70;
	K2_VLA[114] = 94;
	K2_VLA[115] = 70;
	K2_VLA[116] = 94;
	K2_VLA[117] = 74;
	K2_VLA[118] = 96;
	K2_VLA[119] = 74;
	K2_VLA[120] = 96;
	K2_VLA[121] = 80;
	K2_VLA[122] = 100;
	K2_VLA[123] = 80;
	K2_VLA[124] = 100;
	K2_VLA[125] = 74;
	K2_VLA[126] = 102;
	K2_VLA[127] = 74;
	K2_VLA[128] = 116;
	K2_VLA[129] = 58;
	K2_VLA[130] = 9;
	K2_VLA[131] = 110;
	K2_VLA[132] = 46;
	K2_VLA[133] = 102;
	K2_VLA[134] = 64;
	K2_VLA[135] = 100;
	K2_VLA[136] = 64;
	K2_VLA[137] = 102;
	K2_VLA[138] = 30;
	K2_VLA[139] = 98;
	K2_VLA[140] = 20;
	K2_VLA[141] = 94;
	K2_VLA[142] = 30;
	K2_VLA[143] = 96;
	K2_VLA[144] = 64;
	K2_VLA[145] = 98;
	K2_VLA[146] = 64;
	K2_VLA[147] = 98;
	K2_VLA[148] = 20;

	W0_VLA[0] = 8;
	W0_VLA[1] = 13;
	W0_VLA[2] = 124;
	W0_VLA[3] = 64;
	W0_VLA[4] = 120;
	W0_VLA[5] = 72;
	W0_VLA[6] = 120;
	W0_VLA[7] = 64;
	W0_VLA[8] = 110;
	W0_VLA[9] = 78;
	W0_VLA[10] = 102;
	W0_VLA[11] = 64;
	W0_VLA[12] = 110;
	W0_VLA[13] = 58;
	W0_VLA[14] = 118;
	W0_VLA[15] = 54;
	W0_VLA[16] = 120;
	W0_VLA[17] = 50;
	W0_VLA[18] = 122;
	W0_VLA[19] = 46;
	W0_VLA[20] = 116;
	W0_VLA[21] = 40;
	W0_VLA[22] = 108;
	W0_VLA[23] = 42;
	W0_VLA[24] = 120;
	W0_VLA[25] = 28;
	W0_VLA[26] = 126;
	W0_VLA[27] = 28;
	W0_VLA[28] = 8;
	W0_VLA[29] = 130;
	W0_VLA[30] = 28;
	W0_VLA[31] = 136;
	W0_VLA[32] = 28;
	W0_VLA[33] = 146;
	W0_VLA[34] = 36;
	W0_VLA[35] = 148;
	W0_VLA[36] = 50;
	W0_VLA[37] = 136;
	W0_VLA[38] = 44;
	W0_VLA[39] = 132;
	W0_VLA[40] = 46;
	W0_VLA[41] = 134;
	W0_VLA[42] = 48;
	W0_VLA[43] = 136;
	W0_VLA[44] = 44;
	W0_VLA[45] = 9;
	W0_VLA[46] = 134;
	W0_VLA[47] = 48;
	W0_VLA[48] = 142;
	W0_VLA[49] = 54;
	W0_VLA[50] = 164;
	W0_VLA[51] = 116;
	W0_VLA[52] = 132;
	W0_VLA[53] = 132;
	W0_VLA[54] = 118;
	W0_VLA[55] = 130;
	W0_VLA[56] = 94;
	W0_VLA[57] = 120;
	W0_VLA[58] = 110;
	W0_VLA[59] = 90;
	W0_VLA[60] = 132;
	W0_VLA[61] = 132;
	W0_VLA[62] = 106;
	W0_VLA[63] = 72;
	W0_VLA[64] = 5;
	W0_VLA[65] = 102;
	W0_VLA[66] = 64;
	W0_VLA[67] = 100;
	W0_VLA[68] = 66;
	W0_VLA[69] = 94;
	W0_VLA[70] = 56;
	W0_VLA[71] = 96;
	W0_VLA[72] = 54;
	W0_VLA[73] = 102;
	W0_VLA[74] = 64;
	W0_VLA[75] = 5;
	W0_VLA[76] = 102;
	W0_VLA[77] = 66;
	W0_VLA[78] = 98;
	W0_VLA[79] = 68;
	W0_VLA[80] = 102;
	W0_VLA[81] = 74;
	W0_VLA[82] = 104;
	W0_VLA[83] = 76;
	W0_VLA[84] = 110;
	W0_VLA[85] = 90;
	W0_VLA[86] = 2;
	W0_VLA[87] = 112;
	W0_VLA[88] = 88;
	W0_VLA[89] = 120;
	W0_VLA[90] = 72;
	W0_VLA[91] = 9;
	W0_VLA[92] = 132;
	W0_VLA[93] = 62;
	W0_VLA[94] = 128;
	W0_VLA[95] = 20;
	W0_VLA[96] = 122;
	W0_VLA[97] = 52;
	W0_VLA[98] = 122;
	W0_VLA[99] = 64;
	W0_VLA[100] = 124;
	W0_VLA[101] = 60;
	W0_VLA[102] = 128;
	W0_VLA[103] = 114;
	W0_VLA[104] = 130;
	W0_VLA[105] = 80;
	W0_VLA[106] = 130;
	W0_VLA[107] = 68;
	W0_VLA[108] = 132;
	W0_VLA[109] = 62;
	W0_VLA[110] = 11;
	W0_VLA[111] = 130;
	W0_VLA[112] = 40;
	W0_VLA[113] = 128;
	W0_VLA[114] = 38;
	W0_VLA[115] = 124;
	W0_VLA[116] = 40;
	W0_VLA[117] = 126;
	W0_VLA[118] = 42;
	W0_VLA[119] = 130;
	W0_VLA[120] = 40;
	W0_VLA[121] = 128;
	W0_VLA[122] = 46;
	W0_VLA[123] = 128;
	W0_VLA[124] = 50;
	W0_VLA[125] = 126;
	W0_VLA[126] = 50;
	W0_VLA[127] = 126;
	W0_VLA[128] = 42;
	W0_VLA[129] = 124;
	W0_VLA[130] = 40;
	W0_VLA[131] = 126;
	W0_VLA[132] = 46;

	W1_VLA[0] = 10;
	W1_VLA[1] = 13;
	W1_VLA[2] = 124;
	W1_VLA[3] = 64;
	W1_VLA[4] = 120;
	W1_VLA[5] = 72;
	W1_VLA[6] = 120;
	W1_VLA[7] = 64;
	W1_VLA[8] = 110;
	W1_VLA[9] = 78;
	W1_VLA[10] = 102;
	W1_VLA[11] = 64;
	W1_VLA[12] = 110;
	W1_VLA[13] = 58;
	W1_VLA[14] = 118;
	W1_VLA[15] = 54;
	W1_VLA[16] = 120;
	W1_VLA[17] = 50;
	W1_VLA[18] = 122;
	W1_VLA[19] = 46;
	W1_VLA[20] = 116;
	W1_VLA[21] = 40;
	W1_VLA[22] = 108;
	W1_VLA[23] = 42;
	W1_VLA[24] = 120;
	W1_VLA[25] = 28;
	W1_VLA[26] = 126;
	W1_VLA[27] = 28;
	W1_VLA[28] = 8;
	W1_VLA[29] = 130;
	W1_VLA[30] = 28;
	W1_VLA[31] = 136;
	W1_VLA[32] = 28;
	W1_VLA[33] = 146;
	W1_VLA[34] = 36;
	W1_VLA[35] = 148;
	W1_VLA[36] = 50;
	W1_VLA[37] = 136;
	W1_VLA[38] = 44;
	W1_VLA[39] = 132;
	W1_VLA[40] = 46;
	W1_VLA[41] = 134;
	W1_VLA[42] = 48;
	W1_VLA[43] = 136;
	W1_VLA[44] = 44;
	W1_VLA[45] = 9;
	W1_VLA[46] = 134;
	W1_VLA[47] = 48;
	W1_VLA[48] = 142;
	W1_VLA[49] = 54;
	W1_VLA[50] = 164;
	W1_VLA[51] = 116;
	W1_VLA[52] = 132;
	W1_VLA[53] = 132;
	W1_VLA[54] = 118;
	W1_VLA[55] = 130;
	W1_VLA[56] = 94;
	W1_VLA[57] = 120;
	W1_VLA[58] = 110;
	W1_VLA[59] = 90;
	W1_VLA[60] = 132;
	W1_VLA[61] = 132;
	W1_VLA[62] = 106;
	W1_VLA[63] = 72;
	W1_VLA[64] = 5;
	W1_VLA[65] = 102;
	W1_VLA[66] = 64;
	W1_VLA[67] = 100;
	W1_VLA[68] = 66;
	W1_VLA[69] = 94;
	W1_VLA[70] = 56;
	W1_VLA[71] = 96;
	W1_VLA[72] = 54;
	W1_VLA[73] = 102;
	W1_VLA[74] = 64;
	W1_VLA[75] = 5;
	W1_VLA[76] = 102;
	W1_VLA[77] = 66;
	W1_VLA[78] = 98;
	W1_VLA[79] = 68;
	W1_VLA[80] = 102;
	W1_VLA[81] = 74;
	W1_VLA[82] = 104;
	W1_VLA[83] = 76;
	W1_VLA[84] = 110;
	W1_VLA[85] = 90;
	W1_VLA[86] = 2;
	W1_VLA[87] = 112;
	W1_VLA[88] = 88;
	W1_VLA[89] = 120;
	W1_VLA[90] = 72;
	W1_VLA[91] = 9;
	W1_VLA[92] = 132;
	W1_VLA[93] = 62;
	W1_VLA[94] = 128;
	W1_VLA[95] = 20;
	W1_VLA[96] = 122;
	W1_VLA[97] = 52;
	W1_VLA[98] = 122;
	W1_VLA[99] = 64;
	W1_VLA[100] = 124;
	W1_VLA[101] = 60;
	W1_VLA[102] = 128;
	W1_VLA[103] = 114;
	W1_VLA[104] = 130;
	W1_VLA[105] = 80;
	W1_VLA[106] = 130;
	W1_VLA[107] = 68;
	W1_VLA[108] = 132;
	W1_VLA[109] = 62;
	W1_VLA[110] = 11;
	W1_VLA[111] = 130;
	W1_VLA[112] = 40;
	W1_VLA[113] = 128;
	W1_VLA[114] = 38;
	W1_VLA[115] = 124;
	W1_VLA[116] = 40;
	W1_VLA[117] = 126;
	W1_VLA[118] = 42;
	W1_VLA[119] = 130;
	W1_VLA[120] = 40;
	W1_VLA[121] = 128;
	W1_VLA[122] = 46;
	W1_VLA[123] = 128;
	W1_VLA[124] = 50;
	W1_VLA[125] = 126;
	W1_VLA[126] = 50;
	W1_VLA[127] = 126;
	W1_VLA[128] = 42;
	W1_VLA[129] = 124;
	W1_VLA[130] = 40;
	W1_VLA[131] = 126;
	W1_VLA[132] = 46;
	W1_VLA[133] = 16;
	W1_VLA[134] = 98;
	W1_VLA[135] = 46;
	W1_VLA[136] = 100;
	W1_VLA[137] = 50;
	W1_VLA[138] = 98;
	W1_VLA[139] = 54;
	W1_VLA[140] = 92;
	W1_VLA[141] = 58;
	W1_VLA[142] = 86;
	W1_VLA[143] = 56;
	W1_VLA[144] = 82;
	W1_VLA[145] = 48;
	W1_VLA[146] = 86;
	W1_VLA[147] = 40;
	W1_VLA[148] = 90;
	W1_VLA[149] = 38;
	W1_VLA[150] = 94;
	W1_VLA[151] = 40;
	W1_VLA[152] = 92;
	W1_VLA[153] = 40;
	W1_VLA[154] = 88;
	W1_VLA[155] = 42;
	W1_VLA[156] = 86;
	W1_VLA[157] = 48;
	W1_VLA[158] = 88;
	W1_VLA[159] = 52;
	W1_VLA[160] = 92;
	W1_VLA[161] = 54;
	W1_VLA[162] = 98;
	W1_VLA[163] = 50;
	W1_VLA[164] = 98;
	W1_VLA[165] = 46;
	W1_VLA[166] = 16;
	W1_VLA[167] = 154;
	W1_VLA[168] = 104;
	W1_VLA[169] = 156;
	W1_VLA[170] = 108;
	W1_VLA[171] = 154;
	W1_VLA[172] = 112;
	W1_VLA[173] = 148;
	W1_VLA[174] = 116;
	W1_VLA[175] = 142;
	W1_VLA[176] = 114;
	W1_VLA[177] = 138;
	W1_VLA[178] = 106;
	W1_VLA[179] = 142;
	W1_VLA[180] = 98;
	W1_VLA[181] = 146;
	W1_VLA[182] = 96;
	W1_VLA[183] = 150;
	W1_VLA[184] = 98;
	W1_VLA[185] = 148;
	W1_VLA[186] = 98;
	W1_VLA[187] = 144;
	W1_VLA[188] = 100;
	W1_VLA[189] = 142;
	W1_VLA[190] = 106;
	W1_VLA[191] = 146;
	W1_VLA[192] = 110;
	W1_VLA[193] = 150;
	W1_VLA[194] = 112;
	W1_VLA[195] = 154;
	W1_VLA[196] = 108;
	W1_VLA[197] = 154;
	W1_VLA[198] = 104;

	W2_VLA[0] = 12;
	W2_VLA[1] = 13;
	W2_VLA[2] = 124;
	W2_VLA[3] = 64;
	W2_VLA[4] = 120;
	W2_VLA[5] = 72;
	W2_VLA[6] = 120;
	W2_VLA[7] = 64;
	W2_VLA[8] = 110;
	W2_VLA[9] = 78;
	W2_VLA[10] = 102;
	W2_VLA[11] = 64;
	W2_VLA[12] = 110;
	W2_VLA[13] = 58;
	W2_VLA[14] = 118;
	W2_VLA[15] = 54;
	W2_VLA[16] = 120;
	W2_VLA[17] = 50;
	W2_VLA[18] = 122;
	W2_VLA[19] = 46;
	W2_VLA[20] = 116;
	W2_VLA[21] = 40;
	W2_VLA[22] = 108;
	W2_VLA[23] = 42;
	W2_VLA[24] = 120;
	W2_VLA[25] = 28;
	W2_VLA[26] = 126;
	W2_VLA[27] = 28;
	W2_VLA[28] = 8;
	W2_VLA[29] = 130;
	W2_VLA[30] = 28;
	W2_VLA[31] = 136;
	W2_VLA[32] = 28;
	W2_VLA[33] = 146;
	W2_VLA[34] = 36;
	W2_VLA[35] = 148;
	W2_VLA[36] = 50;
	W2_VLA[37] = 136;
	W2_VLA[38] = 44;
	W2_VLA[39] = 132;
	W2_VLA[40] = 46;
	W2_VLA[41] = 134;
	W2_VLA[42] = 48;
	W2_VLA[43] = 136;
	W2_VLA[44] = 44;
	W2_VLA[45] = 9;
	W2_VLA[46] = 134;
	W2_VLA[47] = 48;
	W2_VLA[48] = 142;
	W2_VLA[49] = 54;
	W2_VLA[50] = 164;
	W2_VLA[51] = 116;
	W2_VLA[52] = 132;
	W2_VLA[53] = 132;
	W2_VLA[54] = 118;
	W2_VLA[55] = 130;
	W2_VLA[56] = 94;
	W2_VLA[57] = 120;
	W2_VLA[58] = 110;
	W2_VLA[59] = 90;
	W2_VLA[60] = 132;
	W2_VLA[61] = 132;
	W2_VLA[62] = 106;
	W2_VLA[63] = 72;
	W2_VLA[64] = 5;
	W2_VLA[65] = 102;
	W2_VLA[66] = 64;
	W2_VLA[67] = 100;
	W2_VLA[68] = 66;
	W2_VLA[69] = 94;
	W2_VLA[70] = 56;
	W2_VLA[71] = 96;
	W2_VLA[72] = 54;
	W2_VLA[73] = 102;
	W2_VLA[74] = 64;
	W2_VLA[75] = 5;
	W2_VLA[76] = 102;
	W2_VLA[77] = 66;
	W2_VLA[78] = 98;
	W2_VLA[79] = 68;
	W2_VLA[80] = 102;
	W2_VLA[81] = 74;
	W2_VLA[82] = 104;
	W2_VLA[83] = 76;
	W2_VLA[84] = 110;
	W2_VLA[85] = 90;
	W2_VLA[86] = 2;
	W2_VLA[87] = 112;
	W2_VLA[88] = 88;
	W2_VLA[89] = 120;
	W2_VLA[90] = 72;
	W2_VLA[91] = 9;
	W2_VLA[92] = 132;
	W2_VLA[93] = 62;
	W2_VLA[94] = 128;
	W2_VLA[95] = 20;
	W2_VLA[96] = 122;
	W2_VLA[97] = 52;
	W2_VLA[98] = 122;
	W2_VLA[99] = 64;
	W2_VLA[100] = 124;
	W2_VLA[101] = 60;
	W2_VLA[102] = 128;
	W2_VLA[103] = 114;
	W2_VLA[104] = 130;
	W2_VLA[105] = 80;
	W2_VLA[106] = 130;
	W2_VLA[107] = 68;
	W2_VLA[108] = 132;
	W2_VLA[109] = 62;
	W2_VLA[110] = 11;
	W2_VLA[111] = 130;
	W2_VLA[112] = 40;
	W2_VLA[113] = 128;
	W2_VLA[114] = 38;
	W2_VLA[115] = 124;
	W2_VLA[116] = 40;
	W2_VLA[117] = 126;
	W2_VLA[118] = 42;
	W2_VLA[119] = 130;
	W2_VLA[120] = 40;
	W2_VLA[121] = 128;
	W2_VLA[122] = 46;
	W2_VLA[123] = 128;
	W2_VLA[124] = 50;
	W2_VLA[125] = 126;
	W2_VLA[126] = 50;
	W2_VLA[127] = 126;
	W2_VLA[128] = 42;
	W2_VLA[129] = 124;
	W2_VLA[130] = 40;
	W2_VLA[131] = 126;
	W2_VLA[132] = 46;
	W2_VLA[133] = 6;
	W2_VLA[134] = 86;
	W2_VLA[135] = 40;
	W2_VLA[136] = 92;
	W2_VLA[137] = 64;
	W2_VLA[138] = 100;
	W2_VLA[139] = 42;
	W2_VLA[140] = 82;
	W2_VLA[141] = 54;
	W2_VLA[142] = 104;
	W2_VLA[143] = 56;
	W2_VLA[144] = 86;
	W2_VLA[145] = 40;
	W2_VLA[146] = 6;
	W2_VLA[147] = 140;
	W2_VLA[148] = 66;
	W2_VLA[149] = 140;
	W2_VLA[150] = 80;
	W2_VLA[151] = 134;
	W2_VLA[152] = 68;
	W2_VLA[153] = 144;
	W2_VLA[154] = 74;
	W2_VLA[155] = 134;
	W2_VLA[156] = 76;
	W2_VLA[157] = 140;
	W2_VLA[158] = 66;
	W2_VLA[159] = 6;
	W2_VLA[160] = 146;
	W2_VLA[161] = 96;
	W2_VLA[162] = 148;
	W2_VLA[163] = 120;
	W2_VLA[164] = 136;
	W2_VLA[165] = 100;
	W2_VLA[166] = 154;
	W2_VLA[167] = 106;
	W2_VLA[168] = 138;
	W2_VLA[169] = 116;
	W2_VLA[170] = 146;
	W2_VLA[171] = 96;
	W2_VLA[172] = 6;
	W2_VLA[173] = 116;
	W2_VLA[174] = 80;
	W2_VLA[175] = 122;
	W2_VLA[176] = 90;
	W2_VLA[177] = 114;
	W2_VLA[178] = 86;
	W2_VLA[179] = 122;
	W2_VLA[180] = 82;
	W2_VLA[181] = 116;
	W2_VLA[182] = 90;
	W2_VLA[183] = 116;
	W2_VLA[184] = 80;

	SHIE_VLA[0] = 1;
	SHIE_VLA[1] = 6;
	SHIE_VLA[2] = 172;
	SHIE_VLA[3] = 134;
	SHIE_VLA[4] = 192;
	SHIE_VLA[5] = 128;
	SHIE_VLA[6] = 186;
	SHIE_VLA[7] = 122;
	SHIE_VLA[8] = 168;
	SHIE_VLA[9] = 128;
	SHIE_VLA[10] = 164;
	SHIE_VLA[11] = 134;
	SHIE_VLA[12] = 172;
	SHIE_VLA[13] = 134;

	TORC_VLA[0] = 1;
	TORC_VLA[1] = 4;
	TORC_VLA[2] = 60;
	TORC_VLA[3] = 118;
	TORC_VLA[4] = 74;
	TORC_VLA[5] = 116;
	TORC_VLA[6] = 72;
	TORC_VLA[7] = 114;
	TORC_VLA[8] = 60;
	TORC_VLA[9] = 118;

	SWOR_VLA[0] = 2;
	SWOR_VLA[1] = 2;
	SWOR_VLA[2] = 80;
	SWOR_VLA[3] = 114;
	SWOR_VLA[4] = 100;
	SWOR_VLA[5] = 124;
	SWOR_VLA[6] = 2;
	SWOR_VLA[7] = 82;
	SWOR_VLA[8] = 118;
	SWOR_VLA[9] = 86;
	SWOR_VLA[10] = 114;

	FLAS_VLA[0] = 1;
	FLAS_VLA[1] = 4;
	FLAS_VLA[2] = 162;
	FLAS_VLA[3] = 110;
	FLAS_VLA[4] = 164;
	FLAS_VLA[5] = 120;
	FLAS_VLA[6] = 160;
	FLAS_VLA[7] = 120;
	FLAS_VLA[8] = 162;
	FLAS_VLA[9] = 110;

	RING_VLA[0] = 1;
	RING_VLA[1] = 5;
	RING_VLA[2] = 60;
	RING_VLA[3] = 122;
	RING_VLA[4] = 62;
	RING_VLA[5] = 124;
	RING_VLA[6] = 60;
	RING_VLA[7] = 126;
	RING_VLA[8] = 58;
	RING_VLA[9] = 124;
	RING_VLA[10] = 60;
	RING_VLA[11] = 122;

	SCRO_VLA[0] = 1;
	SCRO_VLA[1] = 5;
	SCRO_VLA[2] = 194;
	SCRO_VLA[3] = 118;
	SCRO_VLA[4] = 192;
	SCRO_VLA[5] = 120;
	SCRO_VLA[6] = 200;
	SCRO_VLA[7] = 126;
	SCRO_VLA[8] = 202;
	SCRO_VLA[9] = 124;
	SCRO_VLA[10] = 194;
	SCRO_VLA[11] = 118;

	FDOR_VLA[0] = 4;
	FDOR_VLA[1] = 2;
	FDOR_VLA[2] = 64;
	FDOR_VLA[3] = 38;
	FDOR_VLA[4] = 192;
	FDOR_VLA[5] = 38;
	FDOR_VLA[6] = 2;
	FDOR_VLA[7] = 64;
	FDOR_VLA[8] = 114;
	FDOR_VLA[9] = 192;
	FDOR_VLA[10] = 114;
	FDOR_VLA[11] = 4;
	FDOR_VLA[12] = 108;
	FDOR_VLA[13] = 114;
	FDOR_VLA[14] = 108;
	FDOR_VLA[15] = 67;
	FDOR_VLA[16] = 148;
	FDOR_VLA[17] = 67;
	FDOR_VLA[18] = 148;
	FDOR_VLA[19] = 114;
	FDOR_VLA[20] = 2;
	FDOR_VLA[21] = 126;
	FDOR_VLA[22] = 94;
	FDOR_VLA[23] = 130;
	FDOR_VLA[24] = 94;

	RDOR_VLA[0] = 3;
	RDOR_VLA[1] = 4;
	RDOR_VLA[2] = 229;
	RDOR_VLA[3] = 16;
	RDOR_VLA[4] = 192;
	RDOR_VLA[5] = 38;
	RDOR_VLA[6] = 192;
	RDOR_VLA[7] = 114;
	RDOR_VLA[8] = 229;
	RDOR_VLA[9] = 136;
	RDOR_VLA[10] = 4;
	RDOR_VLA[11] = 216;
	RDOR_VLA[12] = 128;
	RDOR_VLA[13] = 216;
	RDOR_VLA[14] = 65;
	RDOR_VLA[15] = 200;
	RDOR_VLA[16] = 68;
	RDOR_VLA[17] = 200;
	RDOR_VLA[18] = 119;
	RDOR_VLA[19] = 2;
	RDOR_VLA[20] = 208;
	RDOR_VLA[21] = 92;
	RDOR_VLA[22] = 204;
	RDOR_VLA[23] = 93;

	LDOR_VLA[0] = 3;
	LDOR_VLA[1] = 4;
	LDOR_VLA[2] = 27;
	LDOR_VLA[3] = 16;
	LDOR_VLA[4] = 64;
	LDOR_VLA[5] = 38;
	LDOR_VLA[6] = 64;
	LDOR_VLA[7] = 114;
	LDOR_VLA[8] = 27;
	LDOR_VLA[9] = 136;
	LDOR_VLA[10] = 4;
	LDOR_VLA[11] = 40;
	LDOR_VLA[12] = 128;
	LDOR_VLA[13] = 40;
	LDOR_VLA[14] = 65;
	LDOR_VLA[15] = 56;
	LDOR_VLA[16] = 68;
	LDOR_VLA[17] = 56;
	LDOR_VLA[18] = 119;
	LDOR_VLA[19] = 2;
	LDOR_VLA[20] = 48;
	LDOR_VLA[21] = 92;
	LDOR_VLA[22] = 52;
	LDOR_VLA[23] = 93;

	LPAS_VLA[0] = 2;
	LPAS_VLA[1] = 4;
	LPAS_VLA[2] = 29;
	LPAS_VLA[3] = 38;
	LPAS_VLA[4] = 64;
	LPAS_VLA[5] = 38;
	LPAS_VLA[6] = 64;
	LPAS_VLA[7] = 114;
	LPAS_VLA[8] = 27;
	LPAS_VLA[9] = 114;
	LPAS_VLA[10] = 2;
	LPAS_VLA[11] = 27;
	LPAS_VLA[12] = 16;
	LPAS_VLA[13] = 64;
	LPAS_VLA[14] = 38;

	RPAS_VLA[0] = 2;
	RPAS_VLA[1] = 4;
	RPAS_VLA[2] = 229;
	RPAS_VLA[3] = 38;
	RPAS_VLA[4] = 192;
	RPAS_VLA[5] = 38;
	RPAS_VLA[6] = 192;
	RPAS_VLA[7] = 114;
	RPAS_VLA[8] = 229;
	RPAS_VLA[9] = 114;
	RPAS_VLA[10] = 2;
	RPAS_VLA[11] = 229;
	RPAS_VLA[12] = 16;
	RPAS_VLA[13] = 192;
	RPAS_VLA[14] = 38;

	FPAS_VLA[0] = 0;

	LWAL_VLA[0] = 1;
	LWAL_VLA[1] = 4;
	LWAL_VLA[2] = 27;
	LWAL_VLA[3] = 16;
	LWAL_VLA[4] = 64;
	LWAL_VLA[5] = 38;
	LWAL_VLA[6] = 64;
	LWAL_VLA[7] = 114;
	LWAL_VLA[8] = 27;
	LWAL_VLA[9] = 136;

	RWAL_VLA[0] = 1;
	RWAL_VLA[1] = 4;
	RWAL_VLA[2] = 229;
	RWAL_VLA[3] = 16;
	RWAL_VLA[4] = 192;
	RWAL_VLA[5] = 38;
	RWAL_VLA[6] = 192;
	RWAL_VLA[7] = 114;
	RWAL_VLA[8] = 229;
	RWAL_VLA[9] = 136;

	FWAL_VLA[0] = 2;
	FWAL_VLA[1] = 2;
	FWAL_VLA[2] = 64;
	FWAL_VLA[3] = 38;
	FWAL_VLA[4] = 192;
	FWAL_VLA[5] = 38;
	FWAL_VLA[6] = 2;
	FWAL_VLA[7] = 64;
	FWAL_VLA[8] = 114;
	FWAL_VLA[9] = 192;
	FWAL_VLA[10] = 114;

	LSD_VLA[0] = 1;
	LSD_VLA[1] = 3;
	LSD_VLA[2] = 40;
	LSD_VLA[3] = 128;
	LSD_VLA[4] = 50;
	LSD_VLA[5] = 66;
	LSD_VLA[6] = 58;
	LSD_VLA[7] = 117;

	RSD_VLA[0] = 1;
	RSD_VLA[1] = 3;
	RSD_VLA[2] = 216;
	RSD_VLA[3] = 128;
	RSD_VLA[4] = 206;
	RSD_VLA[5] = 66;
	RSD_VLA[6] = 198;
	RSD_VLA[7] = 117;

	FSD_VLA[0] = 1;
	FSD_VLA[1] = 3;
	FSD_VLA[2] = 108;
	FSD_VLA[3] = 113;
	FSD_VLA[4] = 128;
	FSD_VLA[5] = 67;
	FSD_VLA[6] = 148;
	FSD_VLA[7] = 114;

	LPK_VLA[0] = 1;
	LPK_VLA[1] = 5;
	LPK_VLA[2] = 28;
	LPK_VLA[3] = 100;
	LPK_VLA[4] = 36;
	LPK_VLA[5] = 108;
	LPK_VLA[6] = 32;
	LPK_VLA[7] = 112;
	LPK_VLA[8] = 36;
	LPK_VLA[9] = 120;
	LPK_VLA[10] = 28;
	LPK_VLA[11] = 128;

	RPK_VLA[0] = 1;
	RPK_VLA[1] = 5;
	RPK_VLA[2] = 228;
	RPK_VLA[3] = 100;
	RPK_VLA[4] = 220;
	RPK_VLA[5] = 108;
	RPK_VLA[6] = 224;
	RPK_VLA[7] = 112;
	RPK_VLA[8] = 220;
	RPK_VLA[9] = 120;
	RPK_VLA[10] = 228;
	RPK_VLA[11] = 128;

	LAD_VLA[0] = 11;
	LAD_VLA[1] = 2;
	LAD_VLA[2] = 116;
	LAD_VLA[3] = 24;
	LAD_VLA[4] = 116;
	LAD_VLA[5] = 128;
	LAD_VLA[6] = 2;
	LAD_VLA[7] = 140;
	LAD_VLA[8] = 24;
	LAD_VLA[9] = 140;
	LAD_VLA[10] = 128;
	LAD_VLA[11] = 2;
	LAD_VLA[12] = 116;
	LAD_VLA[13] = 28;
	LAD_VLA[14] = 140;
	LAD_VLA[15] = 28;
	LAD_VLA[16] = 2;
	LAD_VLA[17] = 116;
	LAD_VLA[18] = 40;
	LAD_VLA[19] = 140;
	LAD_VLA[20] = 40;
	LAD_VLA[21] = 2;
	LAD_VLA[22] = 116;
	LAD_VLA[23] = 52;
	LAD_VLA[24] = 140;
	LAD_VLA[25] = 52;
	LAD_VLA[26] = 2;
	LAD_VLA[27] = 116;
	LAD_VLA[28] = 64;
	LAD_VLA[29] = 140;
	LAD_VLA[30] = 64;
	LAD_VLA[31] = 2;
	LAD_VLA[32] = 116;
	LAD_VLA[33] = 76;
	LAD_VLA[34] = 140;
	LAD_VLA[35] = 76;
	LAD_VLA[36] = 2;
	LAD_VLA[37] = 116;
	LAD_VLA[38] = 88;
	LAD_VLA[39] = 140;
	LAD_VLA[40] = 88;
	LAD_VLA[41] = 2;
	LAD_VLA[42] = 116;
	LAD_VLA[43] = 100;
	LAD_VLA[44] = 140;
	LAD_VLA[45] = 100;
	LAD_VLA[46] = 2;
	LAD_VLA[47] = 116;
	LAD_VLA[48] = 112;
	LAD_VLA[49] = 140;
	LAD_VLA[50] = 112;
	LAD_VLA[51] = 2;
	LAD_VLA[52] = 116;
	LAD_VLA[53] = 123;
	LAD_VLA[54] = 140;
	LAD_VLA[55] = 123;

	HUP_VLA[0] = 4;
	HUP_VLA[1] = 6;
	HUP_VLA[2] = 100;
	HUP_VLA[3] = 34;
	HUP_VLA[4] = 92;
	HUP_VLA[5] = 24;
	HUP_VLA[6] = 164;
	HUP_VLA[7] = 24;
	HUP_VLA[8] = 156;
	HUP_VLA[9] = 34;
	HUP_VLA[10] = 100;
	HUP_VLA[11] = 34;
	HUP_VLA[12] = 100;
	HUP_VLA[13] = 24;
	HUP_VLA[14] = 2;
	HUP_VLA[15] = 156;
	HUP_VLA[16] = 34;
	HUP_VLA[17] = 156;
	HUP_VLA[18] = 24;
	HUP_VLA[19] = 2;
	HUP_VLA[20] = 47;
	HUP_VLA[21] = 28;
	HUP_VLA[22] = 96;
	HUP_VLA[23] = 28;
	HUP_VLA[24] = 2;
	HUP_VLA[25] = 161;
	HUP_VLA[26] = 28;
	HUP_VLA[27] = 210;
	HUP_VLA[28] = 28;

	HDN_VLA[0] = 2;
	HDN_VLA[1] = 6;
	HDN_VLA[2] = 100;
	HDN_VLA[3] = 118;
	HDN_VLA[4] = 92;
	HDN_VLA[5] = 128;
	HDN_VLA[6] = 164;
	HDN_VLA[7] = 128;
	HDN_VLA[8] = 156;
	HDN_VLA[9] = 118;
	HDN_VLA[10] = 100;
	HDN_VLA[11] = 118;
	HDN_VLA[12] = 100;
	HDN_VLA[13] = 128;
	HDN_VLA[14] = 2;
	HDN_VLA[15] = 156;
	HDN_VLA[16] = 118;
	HDN_VLA[17] = 156;
	HDN_VLA[18] = 128;

	CEI_VLA[0] = 1;
	CEI_VLA[1] = 2;
	CEI_VLA[2] = 47;
	CEI_VLA[3] = 28;
	CEI_VLA[4] = 210;
	CEI_VLA[5] = 28;
}
