/****************************************
Daggorath PC-Port Version 0.2.1
Richard Hunerlach
November 13, 2002

The copyright for Dungeons of Daggorath
is held by Douglas J. Morgan.
(c) 1982, DynaMicro
*****************************************/

// Dungeons of Daggorath
// PC-Port
// Filename: dod.cpp
//
// All primary objects are declared in global space
// to minimize dereferencing of pointers.  The main
// function simply calls init on the oslink object
// which contains all the SDL setup code.
//
// Every other file that uses these primary objects
// needs to include the objects header and declare
// an external reference to the object, which will
// resolve to the declarations below.  This can
// probably be simplified with some common mechanism.

#include "dod.h"
#include "dodgame.h"
#include "rng.h"
#include "player.h"
#include "object.h"
#include "creature.h"
#include "dungeon.h"
#include "sched.h"
#include "viewer.h"
#include "oslink.h"
#include "parser.h"

dodGame		game;
Coordinate	crd;
RNG			rng;
Player		player;
Object		object;
Creature	creature;
Dungeon		dungeon;
Scheduler	scheduler;
Viewer		viewer;
OS_Link		oslink;
Parser		parser;

// Could include some command line arguments for
// various purposes (like configurations) if desired later.
//
// However, I think a config file would be nicer
//
int main(int argc, char * argv[])
{
	oslink.init();
	return 0;
}
