/****************************************
Daggorath PC-Port Version 0.2.1
Richard Hunerlach
November 13, 2002

The copyright for Dungeons of Daggorath
is held by Douglas J. Morgan.
(c) 1982, DynaMicro
*****************************************/

// Dungeons of Daggorath
// PC-Port
// Filename: dodgame.cpp
//
// Implementation of dodGame class.

//#include <stdio.h>

#include "dodgame.h"
#include "player.h"
#include "object.h"
#include "viewer.h"
#include "sched.h"
#include "creature.h"
#include "parser.h"
#include "dungeon.h"
#include "oslink.h"

extern OS_Link		oslink;
extern Dungeon		dungeon;
extern Parser		parser;
extern Creature		creature;
extern Object		object;
extern Player		player;
extern Viewer		viewer;
extern Scheduler	scheduler;

// Constructor
dodGame::dodGame() : LEVEL(4), AUTFLG(true), hasWon(false)
{
	//
}

// Game initialization
void dodGame::COMINI()
{
	Uint32 ticks1, ticks2;

	scheduler.SYSTCB();
	object.CreateAll();
	player.HBEATF = 0;
	viewer.clearArea(&viewer.TXTSTS);
	viewer.clearArea(&viewer.TXTPRI);
	viewer.VXSCAL = 0x80;
	viewer.VYSCAL = 0x80;
	AUTFLG = scheduler.fadeLoop();
	AUTFLG = false; // TAKE THIS LINE OUT !!!!!!!!!! [Prevents demo from starting]
	player.setInitialObjects(AUTFLG);
	viewer.displayPrepare();
	viewer.DSPMOD = 3;
	viewer.draw_game();

	// Delay with "PREPARE!" on screen
	ticks1 = SDL_GetTicks();
	do
	{
		oslink.process_events();
		ticks2 = SDL_GetTicks();
	} while (ticks2 < ticks1 + viewer.prepPause);
	
	creature.NEWLVL();
	// if autoplay mode, do map, wait, wait
	INIVU();
	viewer.PROMPT();
}

void dodGame::Restart()
{
	Uint32 ticks1, ticks2;

	object.Reset();
	creature.Reset();
	parser.Reset();
	player.Reset();
	scheduler.Reset();
	viewer.Reset();
	hasWon = false;

	dungeon.VFTPTR = 0;
	scheduler.SYSTCB();
	object.CreateAll();
	player.HBEATF = 0;
	player.setInitialObjects(false);
	viewer.displayPrepare();
	viewer.displayCopyright();
	viewer.DSPMOD = 3;
	viewer.draw_game();

	// Delay with "PREPARE!" on screen
	ticks1 = SDL_GetTicks();
	do
	{
		oslink.process_events();
		ticks2 = SDL_GetTicks();
	} while (ticks2 < ticks1 + 2500);
	
	creature.NEWLVL();
	INIVU();
	viewer.PROMPT();
}

void dodGame::LoadGame()
{
	scheduler.LOAD();
	if (game.LEVEL % 2 == 0)
	{
		viewer.VDGINV = false;
	}
	else
	{
		viewer.VDGINV = true;
	}
	viewer.setVid();
	--viewer.UPDATE;
	viewer.draw_game();
	INIVU();
	viewer.PROMPT();
}

// Initializes 3D viewer
void dodGame::INIVU()
{
	viewer.clearArea(&viewer.TXTSTS);
	viewer.clearArea(&viewer.TXTPRI);
	player.HUPDAT();
	++player.HEARTC;
	--player.HEARTF;
	--player.HBEATF;
	viewer.STATUS();
	player.PLOOK();
}
