/****************************************
Daggorath PC-Port Version 0.2.1
Richard Hunerlach
November 13, 2002

The copyright for Dungeons of Daggorath
is held by Douglas J. Morgan.
(c) 1982, DynaMicro
*****************************************/

// Dungeons of Daggorath
// PC-Port
// Filename: object.cpp
//
// Implementation of Object class

#include "object.h"
#include "dodgame.h"
#include "parser.h"
#include "oslink.h"

extern OS_Link	oslink;
extern Parser	parser;
extern dodGame	game;

// Constructor
Object::Object() : K_FLAS(0),
				   K_RING(1),
				   K_SCRO(2),
				   K_SHIE(3),
				   K_SWOR(4),
				   K_TORC(5),
				   OFINDP(0),
				   OFINDF(0),
				   OCBPTR(0),
				   OBJTYP(0),
				   OBJCLS(0),
				   SPEFLG(0),
				   objChannel(1)
{
	ODBTAB[0] = ODB(K_RING, 255, 0, 5);		// Supreme Ring
	ODBTAB[1] = ODB(K_RING, 170, 0, 5);		// Joule Ring
	ODBTAB[2] = ODB(K_SWOR, 150, 64, 64);	// Elvish Sword
	ODBTAB[3] = ODB(K_SHIE, 140, 13, 26);	// Mithril Shield
	ODBTAB[4] = ODB(K_SCRO, 130, 0, 5);		// Seer Scroll
	ODBTAB[5] = ODB(K_FLAS, 70, 0, 5);		// Thews Flask
	ODBTAB[6] = ODB(K_RING, 52, 0, 5);		// Rime Ring
	ODBTAB[7] = ODB(K_SCRO, 50, 0, 5);		// Vision Scroll
	ODBTAB[8] = ODB(K_FLAS, 48, 0, 5);		// Abye Flask
	ODBTAB[9] = ODB(K_FLAS, 40, 0, 5);		// Hale Flask
	ODBTAB[10] = ODB(K_TORC, 70, 0, 5);		// Solar Torch
	ODBTAB[11] = ODB(K_SHIE, 25, 0, 26);	// Bronze Shield
	ODBTAB[12] = ODB(K_RING, 13, 0, 5);		// Vulcan Ring
	ODBTAB[13] = ODB(K_SWOR, 13, 0, 40);	// Iron Sword
	ODBTAB[14] = ODB(K_TORC, 25, 0, 5);		// Lunar Torch
	ODBTAB[15] = ODB(K_TORC, 5, 0, 5);		// Pine Torch
	ODBTAB[16] = ODB(K_SHIE, 5, 0, 10);		// Leather Shield
	ODBTAB[17] = ODB(K_SWOR, 5, 0, 16);		// Wooden Sword
	ODBTAB[18] = ODB(K_RING, 0, 0, 0);		// Incanted Supreme Ring
	ODBTAB[19] = ODB(K_RING, 0, 255, 255);	// Incanted Joule Ring
	ODBTAB[20] = ODB(K_RING, 0, 255, 255);	// Incanted Rime Ring
	ODBTAB[21] = ODB(K_RING, 0, 255, 255);	// Incanted Vulcan Ring
	ODBTAB[22] = ODB(K_RING, 0, 0, 5);		// Gold Ring
	ODBTAB[23] = ODB(K_FLAS, 0, 0, 5);		// Empty Flask
	ODBTAB[24] = ODB(K_TORC, 5, 0, 5);		// Dead Torch

	XXXTAB[0] = XDB(0x00, 0x03, 0x12, 0x00);	// Supreme Ring
	XXXTAB[1] = XDB(0x01, 0x03, 0x13, 0x00);	// Joule Ring
	XXXTAB[2] = XDB(0x03, 0x40, 0x40, 0x00);	// Mithril Shield
	XXXTAB[3] = XDB(0x06, 0x03, 0x14, 0x00);	// Rime Ring
	XXXTAB[4] = XDB(0x0A, 0x02D0, 0x0D, 0x0B);	// Solar Torch
	XXXTAB[5] = XDB(0x0B, 0x60, 0x80, 0x00);	// Bronze Shield
	XXXTAB[6] = XDB(0x0C, 0x03, 0x15, 0x00);	// Vulcan Ring
	XXXTAB[7] = XDB(0x0E, 0x0168, 0x0A, 0x04);	// Lunar Torch
	XXXTAB[8] = XDB(0x0F, 0x00B4, 0x07, 0x00);	// Pine Torch
	XXXTAB[9] = XDB(0x10, 0x6C, 0x80, 0x00);	// Leather Shield
	XXXTAB[10] = XDB(0x18, 0x00, 0x00, 0x00);	// Dead Torch

	strcpy(OMXTAB_load,"413131322323111316141416010408080304");
	Utils::LoadFromHex(OMXTAB_load, OMXTAB);

	strcpy(OBJWGT_load,"05010A19190A");
	Utils::LoadFromHex(OBJWGT_load, OBJWGT);

	strcpy(GENVAL_load,"FFFFFF10110F");
	Utils::LoadFromHex(GENVAL_load, GENVAL);

	strcpy(ADJTAB_load,"1938675848AD282854FAB0A0310ACB266838DA9A224960");
	strcat(ADJTAB_load,"20A652C8282882DE602064969430AC99A5EE20022C94");
	strcat(ADJTAB_load,"201016142966F6064030C527BB45306D560C2E211327B8");
	strcat(ADJTAB_load,"29595706402160971438D850D10590312EF790AE");
	strcat(ADJTAB_load,"284C970580304AE2C8F918523280204C9914");
	strcat(ADJTAB_load,"204EF610280AD8532021485090");
	Utils::LoadFromHex(ADJTAB_load, ADJTAB);

	strcpy(GENTAB_load,"06280CC0CD602064971C30A6393D8C30E6849584292777C880");
	strcat(GENTAB_load,"2968F90D00");
	Utils::LoadFromHex(GENTAB_load, GENTAB);
}

void Object::Reset()
{
	K_FLAS = 0;
	K_RING = 1;
	K_SCRO = 2;
	K_SHIE = 3;
	K_SWOR = 4;
	K_TORC = 5;
	OFINDP = 0;
	OFINDF = 0;
	OCBPTR = 0;
	OBJTYP = 0;
	OBJCLS = 0;
	SPEFLG = 0;

	ODBTAB[0] = ODB(K_RING, 255, 0, 5);		// Supreme Ring
	ODBTAB[1] = ODB(K_RING, 170, 0, 5);		// Joule Ring
	ODBTAB[2] = ODB(K_SWOR, 150, 64, 64);	// Elvish Sword
	ODBTAB[3] = ODB(K_SHIE, 140, 13, 26);	// Mithril Shield
	ODBTAB[4] = ODB(K_SCRO, 130, 0, 5);		// Seer Scroll
	ODBTAB[5] = ODB(K_FLAS, 70, 0, 5);		// Thews Flask
	ODBTAB[6] = ODB(K_RING, 52, 0, 5);		// Rime Ring
	ODBTAB[7] = ODB(K_SCRO, 50, 0, 5);		// Vision Scroll
	ODBTAB[8] = ODB(K_FLAS, 48, 0, 5);		// Abye Flask
	ODBTAB[9] = ODB(K_FLAS, 40, 0, 5);		// Hale Flask
	ODBTAB[10] = ODB(K_TORC, 70, 0, 5);		// Solar Torch
	ODBTAB[11] = ODB(K_SHIE, 25, 0, 26);	// Bronze Shield
	ODBTAB[12] = ODB(K_RING, 13, 0, 5);		// Vulcan Ring
	ODBTAB[13] = ODB(K_SWOR, 13, 0, 40);	// Iron Sword
	ODBTAB[14] = ODB(K_TORC, 25, 0, 5);		// Lunar Torch
	ODBTAB[15] = ODB(K_TORC, 5, 0, 5);		// Pine Torch
	ODBTAB[16] = ODB(K_SHIE, 5, 0, 10);		// Leather Shield
	ODBTAB[17] = ODB(K_SWOR, 5, 0, 16);		// Wooden Sword
	ODBTAB[18] = ODB(K_RING, 0, 0, 0);		// Incanted Supreme Ring
	ODBTAB[19] = ODB(K_RING, 0, 255, 255);	// Incanted Joule Ring
	ODBTAB[20] = ODB(K_RING, 0, 255, 255);	// Incanted Rime Ring
	ODBTAB[21] = ODB(K_RING, 0, 255, 255);	// Incanted Vulcan Ring
	ODBTAB[22] = ODB(K_RING, 0, 0, 5);		// Gold Ring
	ODBTAB[23] = ODB(K_FLAS, 0, 0, 5);		// Empty Flask
	ODBTAB[24] = ODB(K_TORC, 5, 0, 5);		// Dead Torch

	XXXTAB[0] = XDB(0x00, 0x03, 0x12, 0x00);	// Supreme Ring
	XXXTAB[1] = XDB(0x01, 0x03, 0x13, 0x00);	// Joule Ring
	XXXTAB[2] = XDB(0x03, 0x40, 0x40, 0x00);	// Mithril Shield
	XXXTAB[3] = XDB(0x06, 0x03, 0x14, 0x00);	// Rime Ring
	XXXTAB[4] = XDB(0x0A, 0x02D0, 0x0D, 0x0B);	// Solar Torch
	XXXTAB[5] = XDB(0x0B, 0x60, 0x80, 0x00);	// Bronze Shield
	XXXTAB[6] = XDB(0x0C, 0x03, 0x15, 0x00);	// Vulcan Ring
	XXXTAB[7] = XDB(0x0E, 0x0168, 0x0A, 0x04);	// Lunar Torch
	XXXTAB[8] = XDB(0x0F, 0x00B4, 0x07, 0x00);	// Pine Torch
	XXXTAB[9] = XDB(0x10, 0x6C, 0x80, 0x00);	// Leather Shield
	XXXTAB[10] = XDB(0x18, 0x00, 0x00, 0x00);	// Dead Torch

	strcpy(OMXTAB_load,"413131322323111316141416010408080304");
	Utils::LoadFromHex(OMXTAB_load, OMXTAB);

	strcpy(OBJWGT_load,"05010A19190A");
	Utils::LoadFromHex(OBJWGT_load, OBJWGT);

	strcpy(GENVAL_load,"FFFFFF10110F");
	Utils::LoadFromHex(GENVAL_load, GENVAL);

	strcpy(ADJTAB_load,"1938675848AD282854FAB0A0310ACB266838DA9A224960");
	strcat(ADJTAB_load,"20A652C8282882DE602064969430AC99A5EE20022C94");
	strcat(ADJTAB_load,"201016142966F6064030C527BB45306D560C2E211327B8");
	strcat(ADJTAB_load,"29595706402160971438D850D10590312EF790AE");
	strcat(ADJTAB_load,"284C970580304AE2C8F918523280204C9914");
	strcat(ADJTAB_load,"204EF610280AD8532021485090");
	Utils::LoadFromHex(ADJTAB_load, ADJTAB);

	strcpy(GENTAB_load,"06280CC0CD602064971C30A6393D8C30E6849584292777C880");
	strcat(GENTAB_load,"2968F90D00");
	Utils::LoadFromHex(GENTAB_load, GENTAB);
}

void Object::LoadSounds()
{
	char fn[20];
	char fpre[7];
	strcpy(fpre,oslink.soundDir);
	strcat(fpre,oslink.pathSep);

	strcpy(fn,fpre);
	strcat(fn,"0C_gluglg.wav");
	objSound[0] = Mix_LoadWAV(fn);

	strcpy(fn,fpre);
	strcat(fn,"0D_phaser.wav");
	objSound[1] = Mix_LoadWAV(fn);

	strcpy(fn,fpre);
	strcat(fn,"0E_whoop.wav");
	objSound[2] = Mix_LoadWAV(fn);

	strcpy(fn,fpre);
	strcat(fn,"0F_clang.wav");
	objSound[3] = Mix_LoadWAV(fn);

	strcpy(fn,fpre);
	strcat(fn,"10_whoosh.wav");
	objSound[4] = Mix_LoadWAV(fn);

	strcpy(fn,fpre);
	strcat(fn,"11_chuck.wav");
	objSound[5] = Mix_LoadWAV(fn);
}

// Creates all the objects during initialization
void Object::CreateAll()
{
	dodBYTE	a = 0, b, x;
	dodBYTE	OBJCNT, OBJLVL;

	for (x = 0; x < 72; ++x)
	{
		OCBLND[x].clear();
	}

	do
	{
		OBJCNT = (OMXTAB[a] & 0x0F);
		OBJLVL = (OMXTAB[a] >> 4);
		b = OBJLVL;

		do
		{
			x = OBIRTH(a, b);
			OCBLND[x].P_OCOWN = 0xFF;
			++b;
			if (b > 4)
			{
				b = OBJLVL;
			}
			--OBJCNT;
		} while (OBJCNT != 0);

		++a;
	} while (a < 18);
}

// Finds object on the floor in a cell
int Object::OFIND(RowCol rc)
{
	int idx;
	do
	{
		idx = FNDOBJ();
		if (idx == -1)
			return -1;
	} while ( (!((OCBLND[idx].P_OCROW == rc.row) && (OCBLND[idx].P_OCCOL == rc.col))) ||
			 (OCBLND[idx].P_OCOWN != 0) );
	return idx;
}

// Finds objects in the OCB table
int Object::FNDOBJ()
{
	int x = OFINDP;
	if (OFINDF == 0)
	{
		x = -1;
		OFINDF = -1;
	}

	do
	{
		++x;
		OFINDP = x;
		if (x == OCBPTR)
		{
			return -1;
		}
	} while (OCBLND[x].P_OCLVL != game.LEVEL);
	return x;
}

// Returns the object's name.
void Object::OBJNAM(int idx)
{
	if (idx == -1)
	{
		parser.TOKEN[0] = 0x05;
		parser.TOKEN[1] = 0x0D;
		parser.TOKEN[2] = 0x10;
		parser.TOKEN[3] = 0x14;
		parser.TOKEN[4] = 0x19;
		parser.TOKEN[5] = 0xFF;
		return;
	}

	int ctr = 0;
	dodBYTE * X;
	int Xup;
	dodBYTE A;
	
	if (OCBLND[idx].P_OCREV == 0)
	{
		X = &ADJTAB[1];
		A = OCBLND[idx].P_OCTYP;
		while (A != 0xFF)
		{
			parser.EXPAND(X, &Xup, 0);
			X += Xup;
			--A;
		}

		do
		{
			parser.TOKEN[ctr] = parser.STRING[ctr + 2];
		} while (parser.STRING[ctr++ + 2] != 0xFF);

		parser.TOKEN[ctr - 1] = 0;
	}

	X = &GENTAB[1];
	A = OCBLND[idx].P_OCCLS;
	while (A != 0xFF)
	{
		parser.EXPAND(X, &Xup, 0);
		X += Xup;
		--A;
	}

	int offset = ctr;

	do
	{
		parser.TOKEN[ctr] = parser.STRING[ctr - offset + 2];
	} while (parser.STRING[ctr++ - offset + 2] != 0xFF);
}

// Parses an object name
bool Object::PAROBJ()
{
	int		res;
	dodBYTE	A, B;
	
	SPEFLG = 0;
	res = parser.PARSER(GENTAB, &A, &B, true);
	if (res == 0)
	{
		parser.CMDERR();
		return false;
	}
	if (res > 0)
	{
		OBJTYP = A;
		OBJCLS = B;
		return true;
	}

	--SPEFLG;
	res = parser.PARSER(ADJTAB, &A, &B, false);
	if (res <= 0)
	{
		parser.CMDERR();
		return false;
	}
	OBJTYP = A;
	OBJCLS = B;
	res = parser.PARSER(GENTAB, &A, &B, true);
	if (res <= 0)
	{
		parser.CMDERR();
		return false;
	}
	if (B != OBJCLS)
	{
		parser.CMDERR();
		return false;
	}
	return true;
}

// Creates new object
int Object::OBIRTH(dodBYTE OBJTYP, dodBYTE OBJLVL)
{
	dodBYTE tmp;
	int originalOCBPTR = OCBPTR;
	OCBLND[OCBPTR].P_OCTYP = OBJTYP;
	OCBLND[OCBPTR].P_OCLVL = OBJLVL;
	OCBFIL(OBJTYP, OCBPTR);
	if (GENVAL[OCBLND[OCBPTR].P_OCCLS] != 0xFF)
	{
		tmp = OCBLND[OCBPTR].P_OCREV;
		OBJTYP = GENVAL[OCBLND[OCBPTR].P_OCCLS];
		OCBFIL(OBJTYP, OCBPTR);
		OCBLND[OCBPTR].P_OCREV = tmp;
	}
	++OCBPTR;
	return originalOCBPTR;
}

// Fills in default values for object
void Object::OCBFIL(dodBYTE OBJTYP, int ptr)
{
	int ctr = 0;

	OCBLND[ptr].P_OCCLS = ODBTAB[OBJTYP].P_ODCLS;
	OCBLND[ptr].P_OCREV = ODBTAB[OBJTYP].P_ODREV;
	OCBLND[ptr].P_OCMGO = ODBTAB[OBJTYP].P_ODMGO;
	OCBLND[ptr].P_OCPHO = ODBTAB[OBJTYP].P_ODPHO;

	while (ctr < 11)
	{
		if (OBJTYP == XXXTAB[ctr].P_OXIDX)
		{
			OCBLND[ptr].P_OCXX0 = XXXTAB[ctr].P_OXXX0;
			OCBLND[ptr].P_OCXX1 = XXXTAB[ctr].P_OXXX1;
			OCBLND[ptr].P_OCXX2 = XXXTAB[ctr].P_OXXX2;
		}
		++ctr;
	}
}

