/****************************************
Daggorath PC-Port Version 0.2.1
Richard Hunerlach
November 13, 2002

The copyright for Dungeons of Daggorath
is held by Douglas J. Morgan.
(c) 1982, DynaMicro
*****************************************/

// Dungeons of Daggorath
// PC-Port
// Filename: object.h
//
// This class manages the objects (torches, etc.) in the
// game.

#ifndef DOD_OBJECT_HEADER
#define DOD_OBJECT_HEADER

#include "dod.h"

class Object
{
public:
	// Constructor
	Object();

	// Public Interface
	void	CreateAll();
	int		FNDOBJ();
	void	OBJNAM(int idx);
	int		OFIND(RowCol rc);
	int		OBIRTH(dodBYTE OBJCNT, dodBYTE OBJLVL);
	void	OCBFIL(dodBYTE OBJTYP, int ptr);
	bool	PAROBJ();
	void	Reset();
	void	LoadSounds();
	
	// Public Data Membes
	OCB			OCBLND[72];		// Holds most of the object data
	int			OFINDF;
	dodBYTE		ADJTAB[119];
	dodBYTE		GENTAB[30];
	dodBYTE		OBJTYP;
	dodBYTE		OBJCLS;
	dodBYTE		SPEFLG;
	int			OBJWGT[6];
	int			objChannel;
	Mix_Chunk *	objSound[6];

	// Constants
	int			K_FLAS;
	int			K_RING;
	int			K_SCRO;
	int			K_SHIE;
	int			K_SWOR;
	int			K_TORC;

	int			OCBPTR;
	int			OFINDP;

private:
	// Data Fields
	ODB			ODBTAB[25];
	XDB			XXXTAB[11];
	dodBYTE		OMXTAB[18];
	dodBYTE		GENVAL[6];

	char		ADJTAB_load[239];
	char		GENTAB_load[61];
	char		GENVAL_load[13];
	char		OBJWGT_load[13];
	char		OMXTAB_load[51];
};

#endif // DOD_OBJECT_HEADER
