/****************************************
Daggorath PC-Port Version 0.2.1
Richard Hunerlach
November 13, 2002

The copyright for Dungeons of Daggorath
is held by Douglas J. Morgan.
(c) 1982, DynaMicro
*****************************************/

// Dungeons of Daggorath
// PC-Port
// Filename: oslink.h
//
// This class manages the SDL operations, which abstract
// the link to the operating system.  By keeping these
// separate, it will be somewhat easier to change to a
// different library if necessary.

#ifndef OS_LINK_HEADER
#define OS_LINK_HEADER

#include <SDL.h>
#include <SDL_opengl.h>

#include "dod.h"

class OS_Link
{
public:
	// Constructor
	OS_Link();

	// Public Interface
	void init();			// main entry point for dod application
	void quitSDL(int code);	// shuts down SDL before exiting
	void process_events();	// used mainly to retrieve keystrokes

	// Public Data Fields
	int		width;	// actual screen width after video setup
	int		height;	// same for height

	char	gamefile[50];
	int		gamefileLen;
	char	pathSep[2];
	FILE *	fptr;
	char	confDir[5];
	char	soundDir[6];
	char	savedDir[6];

	int		audio_rate;
	Uint16	audio_format; 
	int		audio_channels;
	int		audio_buffers;

private:
	// Internal Implementation
	void handle_key_down(SDL_keysym * keysym);	// keyboard handler

	// Data Fields
	int bpp;	// bits per pixel
	int flags;	// SDL flags
};

#endif // OS_LINK_HEADER
