/****************************************
Daggorath PC-Port Version 0.2.1
Richard Hunerlach
November 13, 2002

The copyright for Dungeons of Daggorath
is held by Douglas J. Morgan.
(c) 1982, DynaMicro
*****************************************/

// Dungeons of Daggorath
// PC-Port
// Filename: parser.h
//
// This class will manage the command parser

#ifndef DOD_PARSER_HEADER
#define DOD_PARSER_HEADER

#include "dod.h"

class Parser
{
public:
	// Constructor
	Parser();

	// Public Interface
	void	KBDPUT(dodBYTE c);
	dodBYTE	KBDGET();
	void	EXPAND(dodBYTE * X, int * Xup, dodBYTE * U);
	dodBYTE	GETFIV(dodBYTE * X, int * Xup, dodBYTE * zeroY);
	void	ASRD(dodBYTE * A, dodBYTE * B, int num);
	bool	GETTOK();
	int		PARSER(dodBYTE * X, dodBYTE * A, dodBYTE * B, bool norm);
	void	CMDERR();
	int		PARHND();
	void	Reset();

	// Public Data Member
	dodSHORT	LINPTR;
	dodBYTE		PARFLG;
	dodBYTE		PARCNT;
	dodBYTE		VERIFY;
	dodBYTE		FULFLG;
	dodBYTE		KBDHDR;
	dodBYTE		KBDTAL;
	dodBYTE		BUFFLG;
	dodBYTE		KBDBUF[33];
	dodBYTE		LINBUF[33];
	dodSHORT	LINEND;
	dodBYTE		TOKEN[33];
	dodBYTE		TOKEND;
	dodBYTE		STRING[35];
	dodBYTE		SWCHAR[11];
	dodBYTE		OBJSTR[33];
	dodBYTE		CMDTAB[69];
	dodBYTE		DIRTAB[26];

	char		CMDTAB_load[139];
	char		DIRTAB_load[53];

	const dodBYTE C_NUL;
	const dodBYTE C_SGH;
	const dodBYTE C_STX;
	const dodBYTE C_ETX;
	const dodBYTE C_EOT;
	const dodBYTE C_ENQ;
	const dodBYTE C_ACK;
	const dodBYTE C_BEL;
	const dodBYTE C_BS;
	const dodBYTE C_HT;
	const dodBYTE C_LF;
	const dodBYTE C_VT;
	const dodBYTE C_FF;
	const dodBYTE C_CR;
	const dodBYTE C_SO;
	const dodBYTE C_SI;
	const dodBYTE C_DLE;
	const dodBYTE C_DC1;
	const dodBYTE C_DC2;
	const dodBYTE C_DC3;
	const dodBYTE C_DC4;
	const dodBYTE C_NAK;
	const dodBYTE C_SYN;
	const dodBYTE C_ETB;
	const dodBYTE C_CAN;
	const dodBYTE C_EM;
	const dodBYTE C_SUB;
	const dodBYTE C_ESC;
	const dodBYTE C_FS;
	const dodBYTE C_GS;
	const dodBYTE C_RS;
	const dodBYTE C_US;
	const dodBYTE C_SP;
	const dodBYTE C_DEL;
	
	const dodBYTE I_SP;
	const dodBYTE I_EXCL;
	const dodBYTE I_BAR;
	const dodBYTE I_QUES;
	const dodBYTE I_DOT;
	const dodBYTE I_CR;
	const dodBYTE I_SHL;
	const dodBYTE I_SHR;
	const dodBYTE I_LHL;
	const dodBYTE I_LHR;
	const dodBYTE I_BS;

	dodBYTE M_PROM1[5];
	dodBYTE M_CURS[3];
	dodBYTE M_ERAS[6];
	dodBYTE CERR[3];

private:
};

#endif // DOD_PARSER_HEADER
