/****************************************
Daggorath PC-Port Version 0.2.1
Richard Hunerlach
November 13, 2002

The copyright for Dungeons of Daggorath
is held by Douglas J. Morgan.
(c) 1982, DynaMicro
*****************************************/

// Dungeons of Daggorath
// PC-Port
// Filename: sched.h
//
// This class manages the scheduler.

#ifndef DOD_SCHEDULER_HEADER
#define DOD_SCHEDULER_HEADER

#include "dod.h"

class Scheduler
{
public:
	// Constructor
	Scheduler();

	// Scaffolding
	//void		printTrace(char * st, int rout);
	//void		printClock();

	// Public Interface
	void		SYSTCB();
	void		SCHED();
	void		CLOCK();
	int			GETTCB();
	bool		fadeLoop();
	void		deathFadeLoop();
	void		winFadeLoop();
	bool		keyCheck();
	bool		keyHandler(SDL_keysym * keysym);
	void		Reset();
	void		SAVE();
	void		LOAD();
	void		LoadSounds();
	bool		EscCheck();
	bool		EscHandler(SDL_keysym * keysym);
	
	// Public Data Fields
	Task	TCBLND[38];

	static const dodSHORT	clockTCB;
	static const dodSHORT	playerTCB;
	static const dodSHORT	luknewTCB;
	static const dodSHORT	hslowTCB;
	static const dodSHORT	burnerTCB;
	static const dodSHORT	cregenTCB;
	static const dodSHORT	cmoveTCB;

	Uint32		curTime;
	Uint32		elapsedTime;

	Mix_Chunk * hrtSound[2];
	int			hrtChannel;

	dodBYTE		ZFLAG;

private:
	// Data Fields
	int			TCBPTR;
	dodBYTE		KBDHDR;
	dodBYTE		KBDTAL;

	dodBYTE		SLEEP;
	dodBYTE		NOISEF;
	dodBYTE		NOISEV;
};

#endif // DOD_SCHEDULER_HEADER
